require.config({
    paths : {
		text : "lib/text"
	}
});

function Log(message) {
	var element = document.createElement("p");

	var str_to_print = "";
	if (typeof message === 'object') {
		str_to_print = JSON.stringify(message);
	} else {
		str_to_print = message;
	}
	element.appendChild(document.createTextNode(str_to_print));

	try {
		// ripulisco dom
		if ($('#customlog').children().html().length > 2500)
			$('#customlog').children().html("reset");
		$('#customlog').children().prepend(element);
	} catch (Exception) {
	}
}

var shared_app = {};
var shared_router = {};
var shared_mainView = {};

/* Richiesti come esterni perché richiamati dalle API di Google e Apple */
function onNotificationGCM(e) {
	Log('EVENT -> RECEIVED:' + e.event);

	switch (e.event) {
		case 'registered' :
			if (e.regid.length > 0) {
				Log('REGISTERED -> REGID:' + e.regid);
				localStorage["NotificationID"] = e.regid;
			}
			break;
		case 'message' :
			if (e.payload.tipo == "partita") {
				var xml = ""
				switch (e.payload.sesso) {
					case 'maschile' :
						xml = "RealTime";
						break;
					case 'femminile' :
						xml = "RealTimeFemminile";
						break;
					default :
						xml = "RealTime";
						break;
				}

				if (e.payload.customdata.CAMPIONATO != undefined && e.payload.customdata.GARA != undefined) {
					shared_app.closePanel();
					if (e.foreground) { // Foreground notification
						Log('--INLINE NOTIFICATION--');
						shared_mainView.router.back({
							pageName : 'homepage',
							force : true
						});
						shared_app.addNotification({
							title : 'Info',
							subtitle : '',
							message : 'Partita: ' + e.message,
							hold : 8000,
							closeOnClick : true,
							onClick : function() {
								shared_router.load('partita', {
									index_campionato : e.payload.customdata.CAMPIONATO,
									index_gara : e.payload.customdata.GARA,
									modulo : 'partita',
									sesso : xml
								});
							},
							media : '<i class="icon icon-refresh"></i>'
						});
					} else { // Coldstart notification
						Log('MESSAGE -> MSG' + JSON.stringify(e.payload));

						if (e.coldstart) {
							Log('--COLDSTART NOTIFICATION--');
							localStorage["loadPreferiti"] = false;
							shared_router.load('homepage', {
								goTo : 'partita',
								goToParameters : {
									index_campionato : e.payload.customdata.CAMPIONATO,
									index_gara : e.payload.customdata.GARA,
									modulo : 'partita',
									sesso : xml
								}
							});
						} else { // Background notification
							Log('--BACKGROUND NOTIFICATION--');
							shared_mainView.router.back({
								pageName : 'homepage',
								force : true
							});
							shared_router.load('partita', {
								index_campionato : e.payload.customdata.CAMPIONATO,
								index_gara : e.payload.customdata.GARA,
								modulo : 'partita',
								sesso : xml
							});
						}
					}
				}
			} else if (e.payload.tipo == "newsletter") {
				if (e.foreground) {
					Log('--INLINE NOTIFICATION--');
					shared_router.load('newsletter', {
						date : e.payload.customdata.date,
						id_newsletter : e.payload.customdata.id_newsletter
					});
				} else {
					if (e.coldstart) {
						Log('--COLDSTART NOTIFICATION--');
						localStorage["loadPreferiti"] = false;
						shared_router.load('homepage', {
							goTo : 'newsletter',
							goToParameters : {
								id_newsletter : e.payload.customdata.id_newsletter,
								date : e.payload.customdata.date
							}
						});
					} else {
						Log('--BACKGROUND NOTIFICATION--');
						shared_router.load('newsletter', {
							date : e.payload.customdata.date,
							id_newsletter : e.payload.customdata.id_newsletter
						});
					}
				}
			} else {
			}
			break;
		case 'error' :
			Log('ERROR -> MSG:' + e.msg);
			break;
		default :
			Log('EVENT -> Unknown, an event was received and we do not know what it is');
			break;
	}
}

function onNotificationAPN(event) {
	if (event.tipo == "partita") {
		if (event.alert) {
			var xml = ""
			switch (event.sesso) {
				case 'maschile' :
					xml = "RealTime";
					break;
				case 'femminile' :
					xml = "RealTimeFemminile";
					break;
				default :
					xml = "RealTime";
					break;
			}

			if (event.CAMPIONATO != undefined && event.GARA != undefined) {
				shared_app.closePanel();
				if (event.foreground == 1) {
					shared_app.addNotification({
						title : 'Info',
						subtitle : '',
						message : 'Partita: ' + event.alert,
						hold : 8000,
						closeOnClick : true,
						onClick : function() {
							shared_mainView.router.back({
								pageName : 'homepage',
								force : true
							});
							shared_router.load('partita', {
								index_campionato : event.CAMPIONATO,
								index_gara : event.GARA,
								modulo : 'partita',
								sesso : xml
							});
						},
						media : '<i class="icon icon-refresh"></i>'
					});
				} else {
					if (event.coldstart == 1) {
						Log('--COLDSTART NOTIFICATION--');
						localStorage["loadPreferiti"] = false;
						shared_router.load('homepage', {
							goTo : 'partita',
							goToParameters : {
								index_campionato : event.CAMPIONATO,
								index_gara : event.GARA,
								modulo : 'partita',
								sesso : xml
							}
						});
					} else {
						Log('--BACKGROUND NOTIFICATION--');
						shared_mainView.router.back({
							pageName : 'homepage',
							force : true
						});
						shared_router.load('partita', {
							index_campionato : event.CAMPIONATO,
							index_gara : event.GARA,
							modulo : 'partita',
							sesso : xml
						});
					}
				}
			}
		}
	} else if (event.tipo == "newsletter") {
		if (event.foreground) {
			Log('--INLINE NOTIFICATION--');
			shared_router.load('newsletter', {
				date : event.date,
				id_newsletter : event.id_newsletter
			});
		} else {
			if (event.coldstart == 1) {
				Log('--COLDSTART NOTIFICATION--');
				localStorage["loadPreferiti"] = false;
				shared_router.load('homepage', {
					goTo : 'newsletter',
					goToParameters : {
						id_newsletter : event.id_newsletter,
						date : event.date
					}
				});
			} else {
				Log('--BACKGROUND NOTIFICATION--');
				shared_router.load('newsletter', {
					date : event.date,
					id_newsletter : event.id_newsletter
				});
			}
		}
	} else {
	}
}

define('app', ['js/router', 'js/utils'], function(Router, Utils) {
	var f7 = new Framework7({
		modalTitle : 'K-Volley',
		uniqueHistory : true,
		uniqueHistoryIgnoreGetParameters : true,
		dynamicPageUrl : 'content-{{name}}',
		swipePanel : 'left',
		animateNavBackIcon : true,
		animatePages : false,
		sortable : false,
		swipeBackPageAnimateShadow : false,
		swipeBackPageAnimateOpacity : false,
		swipeout : false,
		swipeoutNoFollow : true,
		swipePanelNoFollow : false
	});

	f7.showIndicator();
	
	var $$ = Dom7;
	var mainView = f7.addView('.view-main', {
		dynamicNavbar : true,
		domCache : true
	});

	Utils.setApp(f7, $$, mainView);
	shared_router = Router;
	shared_app = f7;
	shared_mainView = mainView;

	$(document).ajaxComplete(function(e) {
		f7.hideIndicator();
	});

	$$(document).on('pageBeforeAnimation', function(e) {
		if (e.detail.page.name == "homepage") {
			if (!$(".navbar").hasClass("transparentbar")) {
				$(".navbar").addClass("transparentbar");
			}
		} else {
			$(".navbar").removeClass("transparentbar");
		}
	});

	$$(document).on('pageAfterAnimation', function(e) {
		// Pulisco i timeout settati in precedenza
		if (e.detail.page.name != "partita" && e.detail.page.name != "commenti") {
			Utils.setLocalConfig("timeouts_enabled", false);
		} else {
			Utils.setLocalConfig("timeouts_enabled", true);
		}

		var fb_button = "";	
		var user = Utils.getLocalConfig("FB_user");
		if(user == "undefined" || user == undefined) {
			fb_button = "fb-logout";
			$$('#fb-logout').hide();
		} else {
			$$('#fb-logout').show();
		}
		
		// Attivo/disattivo il pannello di sinistra
		if (e.detail.page.name == "homepage") {
			f7.params.swipePanel = 'left';
			
			Router.load('homepage', {
				fromBack : true
			});
			// Disattivo lo SwipePanel per Guida, Partita e Log
		} else if (e.detail.page.name == "guida" || e.detail.page.name == "partita" || e.detail.page.name == "commenti" || e.detail.page.name == "log" || e.detail.page.name == "news-dettaglio" || e.detail.page.name.indexOf("smart-select") >= 0) {
			f7.params.swipePanel = false;
		} else {
			f7.params.swipePanel = 'left';
		}
	});
	
	// In caso fossi in Android visualizzo l'iframe (la radio non parte in automatico quindi questa verrà avviata cliccando play/pause)
	if( /(android)/i.test(navigator.userAgent) ) {
		$$('.radio_live').html('<iframe class="radio_off" id="radio_frame" frameborder="no" style="display:none; width: 100%; height: 90px" src="https://share.xdevel.com/api/?platform=streamsolution&get=player&key=9559d221333c25fad35ede24023b6c0a&autoplay=1" scrolling="0"></iframe>');
	}

	$("body").delegate('#share_link', 'click', function(event) {
		Utils.SocialShare('App tempo reale partite, classifiche notifiche e news volley Seria A1 A2 femminile e maschile\n', 'Ciao questa app Volley potrebbe interessarti', 'www/icon.png', 'http://www.kumbe.it/volley', 'Share : http://www.kumbe.it/volley');
	});

	$("body").delegate('.item_radio', 'click', function(event) {
		if($('.radio_live').hasClass("radio_on")) {
			$('.radio_live').removeClass("radio_on").addClass("radio_off");
			$('.item_radio_icon').removeClass("ion-radio-play").addClass("ion-radio-waves");
			
			if( /(android)/i.test(navigator.userAgent) ) {
				$('#radio_frame').contents().find("#pause").click();
			} else {
				$('.radio_live').html('');
			}
		} else {
			$('.radio_live').removeClass("radio_off").addClass("radio_on");
			$('.item_radio_icon').removeClass("ion-radio-waves").addClass("ion-ios-play");
			
			if( /(android)/i.test(navigator.userAgent) ) {
				$('#radio_frame').contents().find("#play").click();
			} else {
				$('.radio_live').html('<img width="30" src="img/stream.png"><iframe class="radio_off" id="radio_frame" frameborder="no" style="display:none; width: 100%; height: 90px" src="https://share.xdevel.com/api/?platform=streamsolution&get=player&key=9559d221333c25fad35ede24023b6c0a&autoplay=1" scrolling="0"></iframe>');
			}
		}
	});
	
	$("body").delegate('.fb-logout', 'click', function(event) { 
		Utils.FBLogout();
	});

	// Imposto tema, layout e notifiche dell'app
	Utils.switchTheme();
	Utils.switchNotifiche();

	// debug su mobile o desktop
	if (f7.device.os == undefined) {
		my_EventListener = "keypress";
		device = "";
		device.uuid = "test_device";
		alert('schiaccia INVIO 2 VOLTE e sei su desktop debug senza commentare nulla');
	} else {
		my_EventListener = "deviceready";
	}

	document.addEventListener(my_EventListener, function() {
		Utils.Log('Loading...');

		Router.init(f7);

		Utils.Log("DEVICE READY");

		Utils.setLocalConfig("loadPreferiti", true);

		var deviceType = (navigator.userAgent.match(/iPad/i)) == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i)) == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";
		if (deviceType != "Android") {
			$$(".esci_menu").hide();
		}

		if (navigator.userAgent.match(/(iPhone|iPod|iPad|Android|BlackBerry)/)) {
			// Utils.SetDati2Use("LEGAVOLLEY_DEV"); // TEMPORANEO
			Utils.SetDati2Use("LEGAVOLLEY_PRD");
			Utils.setLocalConfig("DeviceType", device.platform);
			// Set UUID
			window.plugins.uniqueDeviceID.get(function(uuid) {
				Utils.setLocalConfig("DeviceUUID", uuid);
			}, function(message) {
				Utils.setLocalConfig("DeviceUUID", "ND");
			});
		} else {
			Utils.setLocalConfig("NotificationID", "ND");
			Utils.setLocalConfig("DeviceType", "ND");
			Utils.setLocalConfig("DeviceUUID", "ND");
			// TEMPORANEO
			Utils.SetDati2Use("TEST_LOCALE");
		}

		// tasto indietro Android
		document.addEventListener("backbutton", function() {
			if ($$('.modal-in').length > 0) {
				f7.closeModal();
				return false;
		    } else {
		    	if (mainView.history.length > 1) {
		    		mainView.router.back();
		    	} else {
		    		Utils.exitAppPopup();
		    	}
		    }
		}, false);
		
		// check connessione
		if (navigator.connection !== undefined) {
			var networkState = navigator.connection.type;
			var states = {};
			states[Connection.UNKNOWN] = 'Unknown connection';
			states[Connection.ETHERNET] = 'Ethernet connection';
			states[Connection.WIFI] = 'WiFi connection';
			states[Connection.CELL_2G] = 'Cell 2G connection';
			states[Connection.CELL_3G] = 'Cell 3G connection';
			states[Connection.CELL_4G] = 'Cell 4G connection';
			states[Connection.CELL] = 'Cell generic connection';
			states[Connection.NONE] = 'No network connection';

			if (states[networkState] == 'No network connection') {
				Utils.setLocalConfig("connected", false);
			} else {
				Utils.setLocalConfig("connected", true);
			}
		}
		
		document.addEventListener("online", function() {
			Utils.setLocalConfig("connected", true);
		}, false);
		
		document.addEventListener("offline", function() {
			Utils.setLocalConfig("connected", false);
		}, false);

		// tasto menu Android
		document.addEventListener("menubutton", function() {
			if (f7.params.swipePanel == 'left') {
				f7.openPanel("left");
			}
		}, false);
		
		Utils.RegisterPushNotification();

		// Per velocizzare il caricamento dell'homepage
		ga('create', 'UA-437777-36', {
			'storage' : 'none',
			'clientId' : Utils.getLocalConfig("DeviceUUID")
		});

		ga('set', 'checkProtocolTask', null);
		
		// FACEBOOK INIT
		Utils.FBInit();	
		
		// FACEBOOK LOGOUT
		$("body").delegate('#fb-logout', 'click', function(event) {
			Utils.FBLogout();
		});
		
		// FACEBOOK LIKE PAGE
		$("body").delegate('#fb-like_app', 'click', function(event) {
			Utils.FBLikeApp();
		});

		$$('#kumbe_link').on('click', function() {
			Utils.WindowOpen('http://www.kumbe.it/volley');
		});

		Utils.Log('Applicazione pronta.');

		var primo_avvio = Utils.getLocalConfig("primo_avvio");
		if (primo_avvio == undefined || primo_avvio == true) { // TEMPORANEO
			Utils.setLocalConfig("primo_avvio", false);
			Utils.setLocalConfig("ricevi_notifiche", true);
			
			Utils.setLocalConfig("FB_user", undefined);

			// Rimuovo le notifiche di quell'utente eventualmente presenti nel database
			Utils.RemovePushNotifications(Utils.getLocalConfig("DeviceUUID"));

			Router.load('homepage', {
				'guida' : true
			});
		} else {
			Utils.setLocalConfig("ricevi_notifiche", true);
			Router.load('homepage', {});
		}
	}, false);

	return {
		f7 : f7,
		$$ : $$,
		mainView : mainView,
		router : Router,
		utils : Utils
	};
});