define(["app", "js/models/campionatoModel", "js/models/giornataModel", "js/models/garaModel", "js/models/setModel", "js/calendario/calendarioView", "text!js/homepage/list.html"], function(app, Campionato, Giornata, Gara, Set, CalendarioView, ListTemplate) {
	var sesso = "";
	var modulo = "";
	var show_campionati = false;
	var campionati = [];
	var bindings = [{
		element : '.calendario-item',
		event : 'click',
		handler : showRealTime
	}];

	function init(query) {
		if(app.utils.checkConnection() == true) {
			sesso = query.Sesso;
			modulo = query.modulo;
			hide_campionati = query.hide_campionati;
			app.utils.Log("INIT calendarioController");
	
			var compiled_template = Template7.compile(ListTemplate);
			var html = compiled_template({
				"modulo" : modulo,
				"notifiche" : app.utils.getClassNotifiche
			});
			app.mainView.router.loadPage({
				content : html
			});
	
			app.f7.showIndicator();
			loadCampionati("", false);
	
			$('.pull-to-refresh-content' + '.' + modulo + '-refresh').bind('refresh', function(e) {
				e.stopPropagation();
				refreshResults();
			});
	
			$('#refresh_link_' + modulo).bind('click', function(e) {
				e.stopPropagation();
				refreshResults();
			});
	
			app.utils.googleAnalytics('send', 'pageview', {
				'page' : getHeader()
			});
		} else {
			app.utils.ajaxError();
		}
	}

	function showRealTime() {		
		var index_campionato = $(this).attr('k_custom_id_campionato');
		var index_giornata = $(this).attr('k_custom_id_giornata');
		var index_gara = $(this).attr('k_custom_id_gara');
		
		switch (sesso) {
			case "CalendarioA1" :
			case "CalendarioA2" :
			case "CalendarioCompleto" :
				app.router.load('partita', {
					Sesso : "RealTime",
					modulo : "partita",
					gara : campionati.campionati[index_campionato].giornate[index_giornata].gare[index_gara]
				});
				break;
			case "CalendarioA1Femminile" :
			case "CalendarioA2Femminile" :
			case "CalendarioCompletoFemminile" :
				app.router.load('partita', {
					Sesso : "RealTimeFemminile",
					modulo : "partita",
					gara : campionati.campionati[index_campionato].giornate[index_giornata].gare[index_gara]
				});
				break;
			default :
				break;
		}
	}

	function getHeader() {
		var header = "";
		switch (sesso) {
			case "CalendarioA1" :
				header = "Calendario A1";
				break;
			case "CalendarioA2" :
				header = "Calendario A2";
				break;
			case "CalendarioA1Femminile" :
				header = "Calendario A1 Femminile";
				break;
			case "CalendarioA2Femminile" :
				header = "Calendario A2 Femminile";
				break;
			case "CalendarioCompleto" :
				header = "Calendario Completo";
				break;
			case "CalendarioCompletoFemminile" :
				header = "Calendario Completo Femminile";
				break;
			default :
				break;
		}
		return header;
	}

	function refreshResults() {
		app.f7.showIndicator();
		setTimeout(function() {
			app.f7.hideIndicator();
			loadCampionati("", true);
		}, 1000);
	}

	function loadCampionati(filter, refresh) {
		campionati = [];
		tempInitializeStorage(filter, refresh);
	}

	function showCampionati(temp_campionati, filter, refresh) {
		if (filter) {
			temp_campionati = _.filter(temp_campionati, filter);
		}

		campionati = temp_campionati;

		CalendarioView.render({
			bindings : bindings,
			hide_campionati : hide_campionati,
			header : getHeader(),
			modulo : modulo,
			model : campionati
		});

		if (refresh) {
			app.f7.pullToRefreshDone();

			app.f7.addNotification({
				title : 'Info',
				subtitle : '',
				message : getHeader() + ', dati aggiornati!',
				hold : 2000,
				media : '<i class="icon icon-refresh"></i>'
			});

			app.utils.googleAnalytics('send', 'event', 'list refresh', getHeader() + ', dati aggiornati!');
		}
	}
	
	function isThisMonthCalendarDate(giorno) {
		var it_months = ["gennaio", "febbraio", "marzo", "aprile", "maggio", "giugno", "luglio", "agosto", "settembre", "ottobre", "novembre", "dicembre"];	
		var d_parts = giorno.split(" ");
		
		var d_month = 0;
		for(i = 0;i < 12;i++) {
			if(d_parts[2].toLowerCase() == it_months[i]) {
				d_month = i;
			}
		}
		
		var d_year = d_parts[3];		
		
		var d = new Date(d_year, d_month, 1, 0, 0, 0, 0);
		var d_today = new Date();
		var d_month = new Date(d_today.getFullYear(), d_today.getMonth(), 1, 0, 0, 0, 0);
		
		if(d.getTime() == d_month.getTime()) {
			return false;
		}
		return true;
	}

	function tempInitializeStorage(filter, refresh) {
		var temp_campionati = [];

		$.ajax({
			method : "GET",
			url : app.utils.GetRisorsa(sesso),
			dataType : "xml",
			timeout: 15000,
			beforeSend : function(xhr, opts) {
				if(!app.utils.checkConnection()) {
					xhr.abort();
					app.utils.ajaxError();
				} else {
					app.f7.showIndicator();
				}
			},
			error : function() {
				app.utils.ajaxError();
			},
			success : function(data) {
				app.f7.hideIndicator();
				var gare = [];
				var sets = [];
				if ($(data).find("CAMPIONATO").length > 0) {
					$(data).find("CAMPIONATO").each(function(index, value) {

						giornate = [];
						$(value).find("GIORNATA").each(function(index2, value2) {

							gare = [];
							$(value2).find("GARA").each(function(index3, value3) {
								var nascondi_set = false;

								if ($(value3).attr("SetVintiCasa") == 0 && $(value3).attr("SetVintiFuori") == 0) {
									nascondi_set = true;
								}
								
								var sets = [];
								$(value3).find("SET").each(function(index4, value4) {
									sets.push(new Set({
										"numero" : $(value4).attr("Numero"),
										"puntiCasa" : $(value4).attr("PuntiCasa"),
										"puntiFuori" : $(value4).attr("PuntiFuori")
									}));
								});
								
								var notifica_squadraA = app.utils.GetPushNotification($(value3).attr("SquadraCasa"));
								var notifica_squadraA_lbl = "";
								switch (notifica_squadraA) {
									case "None" :
										notifica_squadraA_lbl = "Nessuna";
										break;
									case "Match" :
										notifica_squadraA_lbl = "Partita";
										break;
									case "Set" :
										notifica_squadraA_lbl = "Set";
										break;
									case "Point" :
										notifica_squadraA_lbl = "Tutti i punti!";
										break;
								}

								var notifica_squadraB = app.utils.GetPushNotification($(value3).attr("SquadraFuori"));
								var notifica_squadraB_lbl = "";
								switch (notifica_squadraB) {
									case "None" :
										notifica_squadraB_lbl = "Nessuna";
										break;
									case "Match" :
										notifica_squadraB_lbl = "Partita";
										break;
									case "Set" :
										notifica_squadraB_lbl = "Set";
										break;
									case "Point" :
										notifica_squadraB_lbl = "Tutti i punti!";
										break;
								}

								var notifiche_list_squadraA = "";
								var values = ["None", "Match", "Set", "Point"];
								$.each(values, function(index, value) {
									label = "";
									switch (value) {
										case "None" :
											label = "Nessuna";
											break;
										case "Match" :
											label = "Partita";
											break;
										case "Set" :
											label = "Set";
											break;
										case "Point" :
											label = "Tutti i punti!";
											break;
									}

									selected = "";
									if (value == notifica_squadraA) {
										selected = 'selected="selected"';
									}

									notifiche_list_squadraA += '<option value="' + value + '" ' + selected + '>' + label + '</option>';
								});

								var notifiche_list_squadraB = "";
								$.each(values, function(index, value) {
									label = "";
									switch (value) {
										case "None" :
											label = "Nessuna";
											break;
										case "Match" :
											label = "Partita";
											break;
										case "Set" :
											label = "Set";
											break;
										case "Point" :
											label = "Tutti i punti!";
											break;
									}

									selected = "";
									if (value == notifica_squadraB) {
										selected = 'selected="selected"';
									}

									notifiche_list_squadraB += '<option value="' + value + '" ' + selected + '>' + label + '</option>';
								});

								var path = "";
								switch (sesso) {
								case "CalendarioA1Femminile" :
								case "CalendarioA2Femminile" :
								case "CalendarioCompletoFemminile" :
									path = "Femminile";
									break;
								case "CalendarioA1" :
								case "CalendarioA2" :
								case "CalendarioCompleto" :
									path = "";
									break;
								default :
									path = "";
									break;
								}	
								
								// Fix squadra Forlì (per l'accento)
								var squadraCasaPath = $(value3).attr("SquadraCasa").split(" ").pop();
								if(squadraCasaPath == "Forlì") {
									squadraCasaPath = "Forli";
								}
								var squadraFuoriPath = $(value3).attr("SquadraFuori").split(" ").pop();
								if(squadraFuoriPath == "Forlì") {
									squadraFuoriPath = "Forli";
								}
								
								gare.push(new Gara({
									"giorno" : jQuery('<div>').html($(value3).attr("Giorno")).text(),
									"ora" : $(value3).attr("Ora"),
									"index_campionato" : index,
									"index_giornata" : index2,
									"index_gara" : index3,
									"squadraCasa" : $(value3).attr("SquadraCasa"),
									"tifosiSquadraCasa" : 0,
									"squadraFuori" : $(value3).attr("SquadraFuori"),
									"tifosiSquadraFuori" : 0,
									"setVintiCasa" : $(value3).attr("SetVintiCasa"),
									"setVintiFuori" : $(value3).attr("SetVintiFuori"),
									"notificaSquadraCasa" : notifica_squadraA_lbl,
									"notifiche_list_squadraA" : notifiche_list_squadraA,
									"notifiche_list_squadraB" : notifiche_list_squadraB,
									"notificaSquadraFuori" : notifica_squadraB_lbl,
									"campionato" : $(value).attr("Serie"),
									"FacebookPostID" : "ND",
									"nascondi_set" : nascondi_set,
									"imageCasa" : 'img/loghi_club/' + $(value).attr("Serie") + path + '/' + squadraCasaPath + '.jpg',
									"imageFuori" : 'img/loghi_club/' + $(value).attr("Serie") + path + '/' + squadraFuoriPath + '.jpg',
									"sets" : sets
								}));
							});
							
							var not_oggi = isThisMonthCalendarDate($(value2).attr("Giorno"));
							
							giornate.push(new Giornata({
								giornata : $(value2).attr("Giornata"),
								fase : $(value2).attr("Fase"),
								giorno : $(value2).attr("Giorno"),
								ora : $(value2).attr("Ora"),
								oggi : not_oggi,
								gare : gare
							}));
						});

						temp_campionati.push(new Campionato({
							"tipo" : $(value).attr("Tipo"),
							"nome" : $(value).attr("Nome"),
							"serie" : $(value).attr("Serie"),
							"giornate" : giornate
						}));
					});
				}

				showCampionati(JSON.parse(JSON.stringify({
					campionati : temp_campionati
				})), filter, refresh);
			}
		});
	}

	return {
		init : init
	};
});