define(['text!js/calendario/calendario-list-item.html'], function(template) {

	var $$ = Dom7;

	function render(params) {						
		if(params.model.campionati.length <= 0) {
			var html = "<div class='content-block'><p><b>Al momento non ci sono partite in calendario.</b></p><p>Riprova più tardi.</p></div>";
		} else {
			var compiled_template = Template7.compile(template);
			var context = {
				model : params.model,
				hide_campionati : params.hide_campionati
			};
			var html = compiled_template(context);
		}
			
		$$('.' + params.modulo + '-list ul').html(html);
		$$('.' + params.modulo + '-list-header').html(params.header);

		// Scrollo al giorno del calendario
		if($('#oggi').position() !== undefined) {
			var contents = $('.page[data-page="' + params.modulo + '"]').contents();
			contents.scrollTop($('#oggi').position().top);
		}
		
		bindEvents(params.bindings);
	}

	function reRender(params) {
		$$('.' + params.modulo + '-list ul').html(template(params.model));
		$$('.' + params.modulo + '-list-header').text(params.header);
	}

	function bindEvents(bindings) {
		for ( var i in bindings) {
			$$(bindings[i].element).on(bindings[i].event, bindings[i].handler);
		}
	}

	return {
		render : render,
		reRender : reRender
	};
});