define(["app", "text!js/commenti/commenti-body.html", "text!js/commenti/commenti-list-item.html", "js/models/commentoModel", "js/commenti/commentiView"], function(app, PopupTemplate, CommentiTemplate, Commento, CommentiView) {
	var post_ID = "";
	var bindings = [{
		element : '.salva_commento',
		event : 'click',
		handler : addComment
	}, {
		element : '.commento_rimuovi',
		event : 'click',
		handler : removeComment
	}, {
		element : '.mi_piace',
		event : 'click',
		handler : addLike
	}, {
		element : '.non_mi_piace',
		event : 'click',
		handler : removeLike
	}];

	function init(query) {
		if(app.utils.checkConnection() == true) {
			app.utils.Log("INIT commentiController");
			
			post_ID = query.gara.FacebookPostID;
	
			var parsed_user = JSON.parse(app.utils.getLocalConfig("FB_user"));
			// var parsed_user = {};
			var compiled_template = Template7.compile(PopupTemplate);
			var html = compiled_template({
				immagine : parsed_user.picture,
				puntiCasa : query.gara.setVintiCasa,
				puntiFuori : query.gara.setVintiFuori,
				numeroSet : (query.gara.sets.length > 0) ? query.gara.sets[query.gara.sets.length - 1].numero : 1,
				setCasa : (query.gara.sets.length > 0 ) ? query.gara.sets[query.gara.sets.length - 1].puntiCasa : 0,
				setFuori : (query.gara.sets.length > 0) ? query.gara.sets[query.gara.sets.length - 1].puntiFuori : 0
			});
	
			app.mainView.router.loadPage({
				content : html
			});
	
			$('.pull-to-refresh-content' + '.commenti-refresh').bind('refresh', function(e) {
				e.stopPropagation();
				refreshResults();
			});
			
			$('.fb_link').bind('click', function(e) {
				e.stopPropagation();
				
				var ids = query.gara.FacebookPostID.split("_");
				app.utils.WindowOpen("https://www.facebook.com/" + ids[0] + "/posts/" + ids[1]);
			});
	
			loadComments(false);
	
			app.utils.googleAnalytics('send', 'pageview', {
					'page' : 'commenti'
			});
		} else {
			app.utils.ajaxError();
		}
	}

	function refreshResults() {
		app.f7.showIndicator();
		setTimeout(function() {
			app.f7.hideIndicator();
			loadComments(true);
		}, 1000);
	}

	function loadComments(refresh) {
		if (app.utils.checkConnection() == true) {
			var user = app.utils.getLocalConfig("FB_user");

			app.f7.showIndicator();
			openFB.api({
				path : '/' + post_ID + '/comments',
				params : {
					limit : '50',
					fields : "id,from,message,can_remove,created_time,like_count,user_likes,attachment"
				},
				success : function(json_data) {
					var commenti = [];
					$.each(json_data.data, function(key, item) {						
						var timestamp = item.created_time;
						
						var parts = timestamp.split("T");
						var data = parts[0];
						var ora = parts[1];
						
						var data_parts = data.split("-");
						var ora_parts = ora.split("+");
						var ora_parts_2 = ora_parts[0].split(":");

						var d = data_parts[2];
						var m = data_parts[1];
						var y = data_parts[0];
						var h = ora_parts_2[0];
						var i = ora_parts_2[1];
						var s = ora_parts_2[2];
						
						var attachment = "";
						var attachment_in = false;
						if(item.attachment != undefined) {
							if(item.attachment.type == "photo" && item.attachment.media != undefined) {
								if(item.attachment.media.image != undefined) {
									attachment = item.attachment.media.image.src;
									attachment_in = true;
								}
							}
						}

						commenti.push(new Commento({
							"id" : item.id,
							"da" : item.from.name,
							"immagine" : "http://graph.facebook.com/" + item.from.id + "/picture",
							"timestamp" : d + '/' + m + '/' + y + ' ' + h + ":" + i + ":" + s,
							"numero_like" : item.like_count,
							"numero_like_positivo" : (item.like_count > 0) ? true : false,
							"piace_utente" : item.user_likes,
							"puo_rimuovere" : item.can_remove,
							"allegato" : attachment,
							"allegato_presente" : attachment_in,
							"testo" : item.message
						}));
					});

					var parsed_user = JSON.parse(user);
					showComments(parsed_user, commenti, refresh);

					app.f7.hideIndicator();
				},
				error : function(error) {
					console.log(error);
					app.f7.hideIndicator();
					app.utils.FBError(error.code);
				}
			});
		} else {
			app.f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
		
		/*
		  $.getJSON( app.utils.GetRisorsa("Commenti"), function( json_data ) {
					var commenti = [];

					$.each(json_data.data, function(key, item) {
						var timestamp = new Date(item.created_time);

						var d = timestamp.getDate();
						var m = timestamp.getMonth() + 1;
						var y = timestamp.getFullYear();
						var h = timestamp.getHours();
						var i = timestamp.getMinutes();
						var s = timestamp.getSeconds();

						commenti.push(new Commento({
							"id" : item.id,
							"da" : item.from.name,
							"immagine" : "http://graph.facebook.com/" + item.from.id + "/picture",
							"timestamp" : (d <= 9 ? '0' + d : d) + '/' + (m <= 9 ? '0' + m : m) + '/' + y + ' ' + (h <= 9 ? '0' + h : h) + ":" + (i <= 9 ? '0' + i : i) + ":" + (s <= 9 ? '0' + s : s),
							"numero_like" : item.like_count,
							"numero_like_positivo" : (item.like_count > 0) ? true : false,
							"piace_utente" : item.user_likes,
							"puo_rimuovere" : item.can_remove,
							"testo" : item.message
						}));
					});

					var parsed_user = {};
					//var parsed_user = JSON.parse(user);
					showComments(parsed_user, commenti, refresh);

					app.f7.hideIndicator();
			});
		 */
	}

	function showComments(user, commenti, refresh) {
		CommentiView.render({
			commenti : commenti,
			user : user,
			bindings : bindings
		});

		if (refresh) {
			app.f7.pullToRefreshDone();
		}
	}

	function addComment() {
		if (app.utils.checkConnection() == true) {
			var commento = app.$$('.mia_textarea').val();
			// Svuoto la textarea del commento
			app.$$('.mia_textarea').val('');
			
			app.f7.showIndicator();
			if (commento != "") {
				openFB.api({
					method : 'POST',
					path : '/' + post_ID + '/comments',
					params : {
						message : commento
					},
					success : function() {
						app.utils.Log("Commento inserito correttamente");

						setTimeout(function() {
							app.f7.hideIndicator();
							loadComments(false);
						}, 500);
					},
					error : function(error) {
						app.f7.hideIndicator();
						alert("Errore nel POST del commento, messaggio: " + error.message);
					}
				});
			} else {
				app.f7.hideIndicator();
				alert("Inserire un commento!");
			}
		} else {
			app.f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}

	function removeComment() {
		var comment_ID = $(this).attr('k_custom_id_commento');
		
		if (app.utils.checkConnection() == true) {
			app.f7.modal({
				title : 'Rimuovi commento',
				text : 'Sei sicuro di voler rimuovere questo commento?',
				buttons : [{
					text : 'SI',
					onClick : function() {
						var comment_ID = $(this).attr('k_custom_id_commento');

						app.f7.showIndicator();
						openFB.api({
							method : 'DELETE',
							path : '/' + comment_ID,
							success : function() {
								setTimeout(function() {
									app.f7.hideIndicator();
									alert("Commento rimosso");
									loadComments(false);
								}, 500);
							},
							error : function(error) {
								app.f7.hideIndicator();
								alert("Errore nel DELETE del commento, messaggio: " + error.message);
							}
						});
					}
				}, {
					text : 'NO',
					onClick : function() {
					}
				}]
			});
		} else {
			app.f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}

	function addLike() {
		if (app.utils.checkConnection() == true) {
			var comment_ID = $(this).attr('k_custom_id_commento');

			app.f7.showIndicator();
			openFB.api({
				method : 'POST',
				path : '/' + comment_ID + '/likes',
				success : function() {
					app.utils.Log("Like aggiunto correttamente");

					setTimeout(function() {
						app.f7.hideIndicator();
						loadComments(false);
					}, 500);
				},
				error : function(error) {
					app.f7.hideIndicator();
					alert("Errore nel POST del like, messaggio: " + error.message);
				}
			});
		} else {
			app.f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}

	function removeLike() {
		if (app.utils.checkConnection() == true) {
			var comment_ID = $(this).attr('k_custom_id_commento');

			app.f7.showIndicator();
			openFB.api({
				method : 'DELETE',
				path : '/' + comment_ID + '/likes',
				success : function() {
					app.utils.Log("Like rimosso correttamente");

					setTimeout(function() {
						app.f7.hideIndicator();
						loadComments(false);
					}, 500);
				},
				error : function(error) {
					app.f7.hideIndicator();
					alert("Errore nel DELETE del like, messaggio: " + error.message);
				}
			});
		} else {
			app.f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}

	return {
		init : init
	};
});