define(["app", "text!js/credits/credits.html", "js/credits/creditsView"], function(app, CreditsTemplate, CreditsView) {
	var bindings = [{
		element : '#show_kumbe',
		event : 'click',
		handler : showKumbe
	}, {
		element : '#mail_kumbe',
		event : 'click',
		handler : mailKumbe
	}];

	function init() {
		app.utils.Log("INIT creditsController");

		var compiled_template = Template7.compile(CreditsTemplate);
		var html = compiled_template({
			"notifiche" : app.utils.getClassNotifiche
		});
		app.mainView.router.loadPage({
			content : html
		});

		var mc = new Hammer.Manager(document.getElementById('easter_egg'));
		mc.add(new Hammer.Tap());
		mc.add(new Hammer.Tap({
			event : 'doubletap',
			taps : 2
		}));

		mc.get('doubletap').recognizeWith('tap');

		mc.on("doubletap", function(ev) {
			app.f7.addNotification({
				title : 'LOG',
				subtitle : '',
				message : 'Log abilitato!',
				hold : 3000,
				closeOnClick : true,
				onClick : function() {
					app.router.load('log', {});
				},
				media : '<i class="icon icon-refresh"></i>'
			});
		});

		CreditsView.render({
			bindings : bindings
		});
		
		app.utils.googleAnalytics('send', 'pageview', {
				'page' : 'credits'
		});
	}
	
	function showKumbe() {
		app.utils.WindowOpen('http://www.kumbe.it/volley');
	}

	function mailKumbe() {
		app.f7.showIndicator();
		setTimeout(function() {
			window.location.href = "mailto:volleyrealtime@kumbe.it";
			app.utils.googleAnalytics('send', 'event','button click', 'mailto kumbe');
			app.f7.hideIndicator();
		}, 500);
	}

	return {
		init : init
	};
});