define(["app", "js/homepage/homepageView", "text!js/homepage/homepage.html"], function(app, HomepageView, ContainerHomepage) {
	var bindings = [{
		element : '.list-panel-home',
		event : 'click',
		handler : showHomepage
	}, {
		element : '.list-panel-classifica-A1-femminile',
		event : 'click',
		handler : showClassificaA1Femminile
	}, {
		element : '.list-panel-calendario-A1-femminile',
		event : 'click',
		handler : showCalendarioA1Femminile
	}, {
		element : '.list-panel-classifica-A2-femminile',
		event : 'click',
		handler : showClassificaA2Femminile
	}, {
		element : '.list-panel-calendario-A2-femminile',
		event : 'click',
		handler : showCalendarioA2Femminile
	}, {
		element : '.list-panel-classifica-A1',
		event : 'click',
		handler : showClassificaA1
	}, {
		element : '.list-panel-calendario-A1',
		event : 'click',
		handler : showCalendarioA1
	}, {
		element : '.list-panel-classifica-A2',
		event : 'click',
		handler : showClassificaA2
	}, {
		element : '.list-panel-calendario-A2',
		event : 'click',
		handler : showCalendarioA2
	}, {
		element : '.list-panel-calendario-completo',
		event : 'click',
		handler : showCalendarioCompleto
	}, {
		element : '.list-panel-calendario-completo-femminile',
		event : 'click',
		handler : showCalendarioCompletoFemminile
	}, {
		element : '.list-panel-realtime-femminile',
		event : 'click',
		handler : showRealTimeFemminile
	}, {
		element : '.list-panel-realtime',
		event : 'click',
		handler : showRealTime
	}, {
		element : '.list-panel-news-femminile',
		event : 'click',
		handler : showNewsFemminile
	}, {
		element : '.list-panel-news',
		event : 'click',
		handler : showNews
	}, {
		element : '.list-panel-notifiche-femminile-A1',
		event : 'click',
		handler : showNotificheFemminileA1
	}, {
		element : '.list-panel-notifiche-A1',
		event : 'click',
		handler : showNotificheA1
	}, {
		element : '.list-panel-notifiche-femminile-A2',
		event : 'click',
		handler : showNotificheFemminileA2
	}, {
		element : '.list-panel-notifiche-A2',
		event : 'click',
		handler : showNotificheA2
	}, {
		element : '.list-panel-close',
		event : 'click',
		handler : closeApp
	}, {
		element : '.list-panel-log',
		event : 'click',
		handler : showLog
	}, {
		element : '.list-panel-credits',
		event : 'click',
		handler : showCredits
	}, {
		element : '.list-panel-guida',
		event : 'click',
		handler : showGuida
	}, {
		element : '.list-panel-feedback',
		event : 'click',
		handler : showFeedback
	}, {
		element : '#show_femminile',
		event : 'click',
		handler : showFemminileMaschile
	}, {
		element : '#show_maschile',
		event : 'click',
		handler : showFemminileMaschile
	}, {
		element : '.preferito',
		event : 'click',
		handler : setPreferito
	}, {
		element : '.night_day',
		event : 'click',
		handler : setTema
	}, {
		element : '.notifiche_checkbox',
		event : 'click',
		handler : setNotifiche
	}, {
		element : '.open-popover-homepage',
		event : 'click',
		handler : showPopOverNotifiche
	}];

	function init(query) {
		app.utils.Log("INIT homepageController");

		var fb_button = "";		
		var user = app.utils.getLocalConfig("FB_user");
		if (user != "undefined" && user != undefined) {
			fb_button = "fb-logout";
		}
		HomepageView.render({
			bindings : bindings,
			fb_button : fb_button,
			notifiche : app.utils.getClassNotifiche(),
			fromBack : query.fromBack
		});
		
		if(user != "undefined" && user != undefined) {
			var parsed_user = JSON.parse(user);
			app.$$('.fb-logout').css('background-image','url(' + parsed_user.picture + ')');
			
			app.$$('#fb-logout').show();
		} else {
			app.$$('#fb-logout').hide();
		}

		if (query.guida == true) {
			app.router.load('guida', {});
		} else {
			if (app.utils.getLocalConfig("loadPreferiti") !== false) {
				// Visualizzo la sezione preferita
				var preferito = app.utils.getLocalConfig("preferito");
				// if (preferito != "" && preferito != undefined) {
				if (preferito != "" && typeof preferito != "undefined") {
					app.f7.showIndicator();
					setTimeout(function() {
						app.f7.hideIndicator();
						$('.' + preferito)[0].click();
					}, 500);
				}
			}
		}

		getPreferito();

		app.utils.setLocalConfig("loadPreferiti", true);
		
		app.utils.googleAnalytics('send', 'pageview', '', {
			'page' : 'Homepage'
		});

		app.f7.hideIndicator();

		// Carico la pagina di dettaglio in caso l'app fosse stata chiusa
		// (fix per evitare problemi con il caricamento delle pagine all'atto
		// dell'apertura dell'app)
		if (query.goTo != "" && query.goTo != undefined && query.goToParameters != undefined) {
			if (query.goTo == "partita") {
				app.router.load(query.goToParameters.modulo, {
					index_campionato : query.goToParameters.index_campionato,
					index_gara : query.goToParameters.index_gara,
					modulo : query.goToParameters.modulo,
					sesso : query.goToParameters.sesso
				});
			}
			if (query.goTo == "newsletter") {
				app.router.load(query.goTo, {
					id_newsletter : query.goToParameters.id_newsletter,
					date : query.goToParameters.date
				});
			}
		}
	}

	function showFemminileMaschile(event) {
		event.preventDefault();
		$(".logo_button_container").addClass("logo_button_container_relative").removeClass("logo_button_container");

		if ($(this).attr("id") == "show_femminile") {
			$(this).addClass('button_attivo');
			$("#show_maschile").removeClass('button_attivo');
			$(".maschile").removeClass('animazione');
			$(".femminile").addClass('animazione');
		} else {
			$(this).addClass('button_attivo');
			$("#show_femminile").removeClass('button_attivo');
			$(".femminile").removeClass('animazione');
			$(".maschile").addClass('animazione');
		}

	}

	function setPreferito(event) {
		event.stopPropagation();
		var classi = $(this).closest('a').attr('class').split(" ");
		var valore_preferito = classi[classi.length - 2];

		$(".preferito").not(this).removeClass("preferito_selezionato");
		$(this).toggleClass("preferito_selezionato");

		if ($(this).hasClass('preferito_selezionato')) {
			app.utils.setLocalConfig('preferito', valore_preferito);

			setTimeout(function() {
				app.f7.addNotification({
					title : 'Ok, capito!',
					subtitle : '',
					message : 'Al prossimo riavvio ti porto a questa sezione.',
					hold : 3000,
					media : '<i class="icon icon-refresh"></i>'
				});
			}, 100);

			app.utils.googleAnalytics('send', 'event', 'button click', 'setPreferito: ' + valore_preferito);
		} else {
			app.utils.setLocalConfig('preferito', '');
		}
	}

	function getPreferito() {
		var preferito = app.utils.getLocalConfig('preferito');
		$(".preferito").each(function() {
			var valore_preferito = $(this).closest('a').attr('class').split(" ").pop();

			if (valore_preferito == preferito) {
				$(this).addClass("preferito_selezionato");
			}
		});
	}

	function showNotificheFemminileA1() {
		app.router.load('notifiche', {
			Campionato : "A1Femminile",
			sesso : "femminile",
			modulo : "notifiche-femminile-A1"
		});
	}

	function showNotificheFemminileA2() {
		app.router.load('notifiche', {
			Campionato : "A2Femminile",
			sesso : "femminile",
			modulo : "notifiche-femminile-A2"
		});
	}

	function showNotificheA1() {
		app.router.load('notifiche', {
			Campionato : "A1",
			sesso : "maschile",
			modulo : "notifiche-A1"
		});
	}

	function showNotificheA2() {
		app.router.load('notifiche', {
			Campionato : "A2",
			sesso : "maschile",
			modulo : "notifiche-A2"
		});
	}

	function closeApp() {
		app.utils.exitAppPopup();
	}

	function showHomepage() {
		app.utils.setLocalConfig("loadPreferiti", false);
		app.mainView.router.back({
			pageName : 'homepage',
			force : true
		});
	}

	function showRealTimeFemminile() {
		app.router.load('partite', {
			Sesso : "RealTimeFemminile",
			modulo : "realtime-femminile"
		});
	}

	function showRealTime() {
		app.router.load('partite', {
			Sesso : "RealTime",
			modulo : "realtime"
		});
	}

	function showNewsFemminile() {
		app.router.load('news', {
			Sesso : "Femminile",
			modulo : "news-femminile"
		});
	}

	function showNews() {
		app.router.load('news', {
			Sesso : "",
			modulo : "news"
		});
	}

	function showCalendarioCompleto() {
		app.router.load('calendario', {
			Sesso : "CalendarioCompleto",
			modulo : "calendario",
			hide_campionati : false
		});
	}

	function showCalendarioCompletoFemminile() {
		app.router.load('calendario', {
			Sesso : "CalendarioCompletoFemminile",
			modulo : "calendario",
			hide_campionati : false
		});
	}

	function showClassificaA1Femminile() {
		app.router.load('classifiche', {
			Campionato : "A1Femminile",
			modulo : "a1-femminile"
		});
	}

	function showCalendarioA1Femminile() {
		app.router.load('calendario', {
			Sesso : "CalendarioA1Femminile",
			modulo : "calendario-a1-femminile",
			hide_campionati : true
		});
	}

	function showClassificaA2Femminile() {
		app.router.load('classifiche', {
			Campionato : "A2Femminile",
			modulo : "a2-femminile"
		});
	}

	function showCalendarioA2Femminile() {
		app.router.load('calendario', {
			Sesso : "CalendarioA2Femminile",
			modulo : "calendario-a2-femminile",
			hide_campionati : true
		});
	}

	function showClassificaA1() {
		app.router.load('classifiche', {
			Campionato : "A1",
			modulo : "a1"
		});
	}

	function showCalendarioA1() {
		app.router.load('calendario', {
			Sesso : "CalendarioA1",
			modulo : "calendario-a1",
			hide_campionati : true
		});
	}

	function showClassificaA2() {
		app.router.load('classifiche', {
			Campionato : "A2",
			modulo : "a2"
		});
	}

	function showCalendarioA2() {
		app.router.load('calendario', {
			Sesso : "CalendarioA2",
			modulo : "calendario-a2",
			hide_campionati : true
		});
	}

	function showLog() {
		app.router.load('log', {});
	}

	function showCredits() {
		app.router.load('credits', {});
	}

	function showGuida() {
		app.router.load('guida', {});
	}
	
	function showFeedback() {
		app.f7.modal({
		    title: 'Feedback',
		    text: "Scrivi un commento oppure dacci un feedback relativo all'app",
		    afterText: '<textarea id="feedback_text" style="resize: none" rows="3" cols="27"></textarea>',
		    buttons: [{
				text: 'Invia',
				bold : true,
				onClick: function () {
					app.utils.sendFeedback(app.$$('#feedback_text').val());
				}
		    },
		    {
		    	text: 'Annulla',
		    	bold: false
		    }]
		});
	}

	function setTema(e) {
		e.preventDefault();

		var layouts = "layout-dark layout-white";

		var layout = "";
		if ($('#imposta-tema').is(':checked') == false) {
			layout = "layout-dark";
			$('#imposta-tema').prop('checked', true);
		} else {
			$('#imposta-tema').prop('checked', false);
		}

		app.utils.setLocalConfig("layout", layout);
		$('body').removeClass(layouts).addClass(layout);

		app.utils.googleAnalytics('send', 'event', 'button click', 'setTema: ' + layout);
	}

	function setNotifiche(e) {
		e.preventDefault();

		if ($('#imposta-notifiche').is(':checked') == false) {
			app.utils.setLocalConfig("ricevi_notifiche", true);
			$('.notifiche').removeClass("notifiche_off").addClass("notifiche_on");
			$('#imposta-notifiche').prop('checked', true);
		} else {
			app.utils.setLocalConfig("ricevi_notifiche", false);
			$('.notifiche').removeClass("notifiche_on").addClass("notifiche_off");
			$('#imposta-notifiche').prop('checked', false);
		}
	}

	function showPopOverNotifiche() {
		var clickedLink = this;

		var popoverContent = "";
		if ($(this).attr('id') == "popover-maschile") {
			popoverContent += '<li><a href="#" class="list-button close-popover popover-A1 item-link">Notifiche A1</a></li>' + '<li><a href="#" class="list-button close-popover popover-A2 item-link">Notifiche A2</a></li>';
		} else {
			popoverContent += '<li><a href="#" class="list-button close-popover popover-femminile-A1 item-link">Notifiche Femminile A1</a></li>' + '<li><a href="#" class="list-button close-popover popover-femminile-A2 item-link">Notifiche Femminile A2</a></li>';
		}

		var popoverHTML = '<div class="popover popover-links">' + '<div class="popover-inner">' + '<div class="list-block">' + '<ul>' + popoverContent + '</ul>' + '</div>' + '</div>' + '</div>';

		app.f7.popover(popoverHTML, clickedLink, true);

		$('.popover-A1').on('click', function() {
			showNotificheA1();
		});
		$('.popover-A2').on('click', function() {
			showNotificheA2();
		});
		$('.popover-femminile-A1').on('click', function() {
			showNotificheFemminileA1();
		});
		$('.popover-femminile-A2').on('click', function() {
			showNotificheFemminileA2();
		});
	}

	return {
		init : init
	};
});