define(["app", "text!js/newsletter/newsletter.html"], function(app, ContainerNews) {
	var bindings = [];

	function init(query) {
		loadNewsletter(query.id_newsletter);
	}
	
	function loadNewsletter(id_newsletter) {
		$.ajax({
			method : "POST",
			async : true,
			data : {
				id_newsletter : id_newsletter
			},
			url : app.utils.GetRisorsa("Newsletter"),
			dataType : "json",
			success : function(data) {
				showNewsletter(data.RESULT);
			}
		});
	}	
	
	function showNewsletter(data) {
		var compiled_template = Template7.compile(ContainerNews);
		
		var html = compiled_template({
			"date" : data.date,
			"content" : data.content
		});
		
		var popupHTML = '<div class="popup">' + html + '</div>';
		
		app.f7.popup(popupHTML);

		app.utils.googleAnalytics('send', 'pageview', {
			'page' : 'Newsletter del ' + data.date
		});
	}

	return {
		init : init
	};
});