define(["app", "js/partita/partitaView", "js/models/garaModel", "js/models/setModel", "text!js/homepage/dettaglio.html", "text!js/partita/login.html"], function(app, PartitaView, Gara, Set, ContainerDettaglio, LoginPopup) {
	var index_campionato = "";
	var index_gara = "";
	var gara = [];
	var sesso = "";
	var bindings = [{
		element : '#share_partita',
		event : 'click',
		handler : sharePartita
	}, {
		element : '#squadraA',
		event : 'click',
		handler : setNotificationPartitaA
	}, {
		element : '#squadraB',
		event : 'click',
		handler : setNotificationPartitaB
	}, {
		element : '.selezione_notifiche_push_squadraA',
		event : 'change',
		handler : setNotificationPartita
	}, {
		element : '.selezione_notifiche_push_squadraB',
		event : 'change',
		handler : setNotificationPartita
	}, {
		element : '.tifosi-squadra',
		event : 'click',
		handler : showClassifica
	}, {
		element : '.aggiornamento_automatico',
		event : 'click',
		handler : refreshResults
	}, {
		element : '.commenta_live',
		event : 'click',
		handler : showComments
	}, {
		element : '.mipiace_live',
		event : 'click',
		handler : showLikes
	}];

	function init(query) {
		if(app.utils.checkConnection() == true) {
			app.utils.clearAllTimeouts();			
	
			var compiled_template = Template7.compile(ContainerDettaglio);
			var html = compiled_template({
				"modulo" : query.modulo,
				"notifiche" : app.utils.getClassNotifiche
			});
			app.mainView.router.loadPage({
				content : html
			});
			
			index_campionato = query.index_campionato;
			index_gara = query.index_gara;
			sesso = query.sesso;
	
			app.f7.showIndicator();
			if(query.gara != undefined) {
				showGara(query.gara);
			} else {
				loadGara("", false);
			}
	
			app.utils.googleAnalytics('send', 'pageview', {
				'page' : 'Pagina Live ' + sesso + ''
			});
		} else {
			app.utils.ajaxError();
		}
	}
	
	function showGara(temp_gara) {
		gara = temp_gara;
		
		PartitaView.render({
			model : JSON.parse(JSON.stringify(gara)),
			loggato : false,
			show_fb_components : false,
			notInCalendario : false,
			bindings : bindings
		});
		app.f7.hideIndicator();
	}
	
	function FBLogin() {		
		app.utils.googleAnalytics('send', 'event', 'button click', 'Tentativo di login dell utente');
		if (app.utils.checkConnection() == true) {
			app.f7.showIndicator();
			openFB.login(function(response) {
				if (response.status === 'connected') {
					// Ottengo i dati dell'utente
					openFB.api({
						path : '/me',
						params : {
							fields : "picture,gender,id,first_name,last_name,name"
						},
						success : function(data) {
							var user_to_save = {};
							// Salvo i dati dell'utente
							user_to_save.id = data.id;
							user_to_save.first_name = data.first_name;
							user_to_save.last_name = data.last_name;
							user_to_save.gender = data.gender;
							user_to_save.locale = data.locale;
							user_to_save.name = data.name;
							user_to_save.picture = data.picture.data.url;
							user_to_save.token = response.authResponse.token;

							// Imposto l'immagine in alto a destra
							app.$$('.fb-button').removeClass('fb-login').addClass('fb-logout');
							app.$$('.fb-logout').css('background-image', 'url(' + user_to_save.picture + ')');
							
							// Visualizzo il bottone per il logout
							app.$$('.fb-logout').show();

							app.utils.setLocalConfig("FB_user", JSON.stringify(user_to_save));
							
							app.f7.addNotification({
								title : 'Facebook',
								subtitle : '',
								message : 'Login effettuato con successo',
								hold : 1000,
								media : '<i class="icon icon-refresh"></i>'
							});

							app.f7.hideIndicator();
							app.utils.Log("Login effettuato con successo, token: " + response.authResponse.token);
							
							// Ricarico la pagina
							setTimeout(function() {
								refreshResults();
							}, 1000);
						},
						error : function(error) {
							app.utils.Log("I dati del profilo non possono essere ottenuti");
						}
					});
					
					setTimeout(function() {
						app.f7.hideIndicator();
					}, 1000);
				} else {
					app.f7.hideIndicator();
					app.utils.Log("Login fallito, errore: " + response.error);
				}
			}, {
				scope : 'publish_actions'
			});
		} else {
			app.f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}

	function showComments() {
		app.utils.googleAnalytics('send', 'event', 'button click', 'Click su commenta');
		if (app.utils.checkConnection() == true) {
			var user = app.utils.getLocalConfig("FB_user");		
			// Sono loggato
			if (user != "undefined" && user != undefined) {
				app.router.load('commenti', {gara : gara});
			} else { // Non sono loggato
				// Mi loggo
				var compiled_template = Template7.compile(LoginPopup);
				var popup_HTML = '<div class="popup">' + compiled_template({
					titolo : 'Commenta su Facebook',
					testo : 'vorrebbe farti commentare le partite live con il tuo account di Facebook.'
				}) + '</div>';

				app.f7.popup(popup_HTML, true);
				
				$( "#fb-login" ).on( "click",  function() {
					FBLogin();
				});
			}
		} else {
			app.f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
		/*
		 * app.router.load('commenti', {gara : gara});
		 */
	}
	
	function showLikes() {
		if (app.utils.checkConnection() == true) {
			var user = app.utils.getLocalConfig("FB_user");		
			// Sono loggato
			if (user != "undefined" && user != undefined) {
				if(!gara.mipiace) {
					addLikePartita();
				} else {
					removeLikePartita();
				}
			} else { // Non sono loggato
				// Mi loggo
				var compiled_template = Template7.compile(LoginPopup);
				var popup_HTML = '<div class="popup">' + compiled_template({
					titolo : 'Like Facebook',
					testo : 'vorrebbe farti mettere mi piace a questa partita con il tuo account di Facebook.'
				}) + '</div>';

				app.f7.popup(popup_HTML, true);
				
				$( "#fb-login" ).on( "click",  function() {
					FBLogin();
				});
			}
		} else {
			app.f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}
	
	function addLikePartita() {
		app.utils.googleAnalytics('send', 'event', 'button click', 'Like partita');
		if (app.utils.checkConnection() == true) {
			app.f7.showIndicator();
			openFB.api({
				method : 'POST',
				path : '/' + gara.FacebookPostID + '/likes',
				success : function() {
					app.utils.Log("Like alla partita aggiunto correttamente");
					
					gara.mipiace = true;
					refreshResults();
				},
				error : function(error) {
					app.f7.hideIndicator();
					app.utils.Log("Errore nel POST del like, messaggio: " + error.message);
				}
			});
		} else {
			app.f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}
	
	function removeLikePartita() {
		app.utils.googleAnalytics('send', 'event', 'button click', 'Dislike partita');
		if (app.utils.checkConnection() == true) {
			app.f7.showIndicator();
			openFB.api({
				method : 'DELETE',
				path : '/' + gara.FacebookPostID + '/likes',
				success : function() {
					app.utils.Log("Like alla partita rimosso correttamente");
					
					gara.mipiace = false;
					refreshResults();
				},
				error : function(error) {
					app.f7.hideIndicator();
					app.utils.Log("C'è stato un problema con la rimozione del like, messaggio: " + error.message);
				}
			});
		} else {
			app.f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}

	function setNotificationPartita() {
		var class_el = $(this).attr("class");

		if (class_el !== undefined) {
			var squadra = $(this).attr("name");
			var evento = $(this).val();

			var filter_ID = "";
			if (class_el == "selezione_notifiche_push_squadraA") {
				filter_ID = "squadraA";
			} else if (class_el == "selezione_notifiche_push_squadraB") {
				filter_ID = "squadraB";
			} else {
			}

			var xml = "";
			switch (sesso) {
				case "RealTime" :
					xml = 'maschile';
					break;
				case "RealTimeFemminile" :
					xml = 'femminile';
					break;
				default :
					xml = 'maschile';
					break;
			}

			app.utils.SetPushNotification(squadra, evento, xml, {
				filter : "partita",
				filter_ID : filter_ID,
				id : "",
				mainView : app.mainView
			});
		}
	}

	function setNotificationPartitaA() {
		setNotificationPartita("squadraA");
	}

	function setNotificationPartitaB() {
		setNotificationPartita("squadraB");
	}

	function sharePartita() {
		var currentdate = new Date();
		var datetime = currentdate.getDate() + "/" + (currentdate.getMonth() + 1) + "/" + currentdate.getFullYear() + "  " + currentdate.getHours() + ":" + currentdate.getMinutes() + ":" + currentdate.getSeconds();

		app.utils.SocialShare(datetime + "\n\n" + gara.squadraCasa + "\n" + gara.setVintiCasa + ' - ' + gara.setVintiFuori + "\n" + gara.squadraFuori + "\n\nScarica l'App adesso:\n", 'Risultato Live Volley', 'www/icon.png', 'http://www.kumbe.it/volley', 'Share partita: ' + gara.squadraCasa + ' - ' + gara.squadraFuori + ' ' + gara.setVintiCasa + ' - ' + gara.setVintiFuori);
	}

	function showClassifica() {
		var campionato = gara.campionato;

		var sex;
		switch (sesso) {
			case "RealTime" :
				sex = "";
				break;
			case "RealTimeFemminile" :
				sex = "Femminile";
				break;
			default :
				break;
		}

		var modulo = (sex == "" ? campionato.toLowerCase() : campionato.toLowerCase() + "-" + sex.toLowerCase());

		var oggetto = {
			Campionato : campionato + sex,
			modulo : modulo
		};
		app.router.load('classifiche', oggetto);
	}

	function refreshResults() {		
		app.utils.clearAllTimeouts();
		if (app.utils.getLocalConfig("timeouts_enabled") == "true") {
			loadGara("", true);
		} else {
			setTimeout(refreshResults, 5000);
		}
	}

	function loadGara(filter, refresh) {		
		gara = [];
		tempInitializeStorage(filter, refresh);
	}

	function showPartita(temp_gara, filter, refresh) {
		if (filter) {
			temp_gara = _.filter(temp_gara, filter);
		}

		gara = temp_gara;
		
		var loggato = false;
		var user = app.utils.getLocalConfig("FB_user");		
		if ((user != "undefined" && user != undefined) && gara.FacebookPostID != "ND") {
			var parsed_user = JSON.parse(user);
			loggato = true;
			
			openFB.api({
				path : '/' + gara.FacebookPostID + '/likes',
				params : {
					summary : true,
					fields : "id"
				},
				success : function(json_data) {		
					var mipiace = false;
					$.each(json_data.data, function(key, item) {
						if(item.id == parsed_user.id) {
							mipiace = true;
						}
					});
					gara.mipiace = mipiace;

					PartitaView.render({
						model : gara,
						loggato : loggato,
						show_fb_components : true,
						notInCalendario : true,
						bindings : bindings
					});
				}, 
				error : function(error) {
					app.utils.Log("Errore nell'ottenimento del like dell'utente, messaggio: " + error.message);
				}
			});
		} else {
			var show_fb_components = true;
			if(gara.FacebookPostID == "ND") {
				show_fb_components = false;
			}
			PartitaView.render({
				model : gara,
				loggato : loggato,
				show_fb_components : show_fb_components,
				notInCalendario : true,
				bindings : bindings
			});
		}
		
		var hideNotification = false;		
		if ((user != "undefined" && user != undefined) && gara.FacebookPostID != "ND") {
			if($(".riga_riepilogo").get(0)){
				hideNotification = true;
				
				var html_string = '<h1 class="set">' + gara.setVintiCasa + '<blink>-</blink>' + gara.setVintiFuori;
				if(gara.sets.length > 0) {
					html_string += '<span class="set_commenti"> (' + gara.sets[gara.sets.length - 1].numero + '° SET &nbsp;' +
					  '<span class="ui-li-count punti">' + gara.sets[gara.sets.length - 1].puntiCasa + ' - ' + gara.sets[gara.sets.length - 1].puntiFuori + '</span>)' +
					  '</span>' +
					  '</h1>';
				}
				  
				app.$$('.riga_riepilogo').html(html_string);
			}
			
			setTimeout(function(){ 
				openFB.api({
					path : '/' + gara.FacebookPostID + '/likes',
					params : {
						summary : true
					},
					success : function(data) {					
						count_likes = data.summary.total_count;					
						app.$$('.count_mipiace').html(count_likes);
					}, 
					error : function(error) {
						app.utils.Log("Errore nell'ottenimento del numero di likes, messaggio: " + error.message);
					}
				});
				
				openFB.api({
					path : '/' + gara.FacebookPostID + '/comments',
					params : {
						summary : true
					},
					success : function(data) {					
						count_commenti = data.summary.total_count;					
						app.$$('.count_commenti').html(count_commenti);
					}, 
					error : function(error) {
						app.utils.Log("Errore nell'ottenimento del numero di commenti, messaggio: " + error.message);
					}
				});
			}, 1000);
		}

		if (refresh && !hideNotification) {
			app.f7.pullToRefreshDone();
			app.f7.addNotification({
				title : 'Info',
				subtitle : '',
				message : 'Partita: ' + gara.squadraCasa + ' vs ' + gara.squadraFuori + ', dati aggiornati!',
				hold : 2000,
				media : '<i class="icon icon-refresh"></i>'
			});		
			
			app.utils.googleAnalytics('send', 'event', 'list refresh', 'Partita: ' + gara.squadraCasa + ' vs ' + gara.squadraFuori + ', dati aggiornati!');
		}
		app.f7.hideIndicator();
	}

	function tempInitializeStorage(filter, refresh) {
		var temp_gara = [];
		var sets = [];
		$.ajax({
			method : "GET",
			async : true,
			url : app.utils.GetRisorsa(sesso),
			dataType : "xml",
			timeout: 15000,
			beforeSend : function(xhr, opts) {
				if(!app.utils.checkConnection()) {
					xhr.abort();
					app.utils.ajaxError();
				} else {
					app.f7.showIndicator();
				}
			},
			error : function() {
				app.utils.ajaxError();
			},
			success : function(data) {
				temp_campionato = $(data).find("CAMPIONATO")[index_campionato];
				temp_gara = $(temp_campionato).find("GARA")[index_gara];

				$(temp_gara).find("SET").each(function(index, value) {
					sets.push(new Set({
						"numero" : $(value).attr("Numero"),
						"puntiCasa" : $(value).attr("PuntiCasa"),
						"puntiFuori" : $(value).attr("PuntiFuori")
					}));
				});

				var notifica_squadraA = app.utils.GetPushNotification($(temp_gara).attr("SquadraCasa"));
				var notifica_squadraA_lbl = "";
				switch (notifica_squadraA) {
					case "None" :
						notifica_squadraA_lbl = "Nessuna";
						break;
					case "Match" :
						notifica_squadraA_lbl = "Partita";
						break;
					case "Set" :
						notifica_squadraA_lbl = "Set";
						break;
					case "Point" :
						notifica_squadraA_lbl = "Tutti i punti!";
						break;
				}

				var notifica_squadraB = app.utils.GetPushNotification($(temp_gara).attr("SquadraFuori"));
				var notifica_squadraB_lbl = "";
				switch (notifica_squadraB) {
					case "None" :
						notifica_squadraB_lbl = "Nessuna";
						break;
					case "Match" :
						notifica_squadraB_lbl = "Partita";
						break;
					case "Set" :
						notifica_squadraB_lbl = "Set";
						break;
					case "Point" :
						notifica_squadraB_lbl = "Tutti i punti!";
						break;
				}

				var notifiche_list_squadraA = "";
				var values = ["None", "Match", "Set", "Point"];
				$.each(values, function(index, value) {
					label = "";
					switch (value) {
						case "None" :
							label = "Nessuna";
							break;
						case "Match" :
							label = "Partita";
							break;
						case "Set" :
							label = "Set";
							break;
						case "Point" :
							label = "Tutti i punti!";
							break;
					}

					selected = "";
					if (value == notifica_squadraA) {
						selected = 'selected="selected"';
					}

					notifiche_list_squadraA += '<option value="' + value + '" ' + selected + '>' + label + '</option>';
				});

				var notifiche_list_squadraB = "";
				$.each(values, function(index, value) {
					label = "";
					switch (value) {
						case "None" :
							label = "Nessuna";
							break;
						case "Match" :
							label = "Partita";
							break;
						case "Set" :
							label = "Set";
							break;
						case "Point" :
							label = "Tutti i punti!";
							break;
					}

					selected = "";
					if (value == notifica_squadraB) {
						selected = 'selected="selected"';
					}

					notifiche_list_squadraB += '<option value="' + value + '" ' + selected + '>' + label + '</option>';
				});

				var path = "";
				switch (sesso) {
					case "RealTimeFemminile" :
						path = "Femminile";
						break;
					case "RealTime" :
						path = "";
						break;
					default :
						path = "";
						break;
				}

				var tifosiSquadraCasa = 0;
				var tifosiSquadraFuori = 0;
				$(data).find("InfoSquadra").each(function(index, value) {
					if ($(value).attr('name') == $(temp_gara).attr("SquadraCasa")) {
						tifosiSquadraCasa = $(value).attr('tifosi');
					}
					if ($(value).attr('name') == $(temp_gara).attr("SquadraFuori")) {
						tifosiSquadraFuori = $(value).attr('tifosi');
					}
				});
				
				var FacebookPostID = "ND"; 
				var numeroLikes = 0;
				var numeroCommenti = 0;
				// var FacebookPostID = "886111768088397_898981506801423"; // ESEMPIO
				$(data).find("FacebookPost").each(function(index, value) {
					if ($(value).attr('SquadraCasa') == $(temp_gara).attr("SquadraCasa") && $(value).attr('SquadraFuori') == $(temp_gara).attr("SquadraFuori")) {
						FacebookPostID = $(value).attr('FacebookPostID');
						numeroLikes = $(value).attr('NumeroLikes');
						numeroCommenti = $(value).attr('NumeroCommenti');
					}
				});
				
				// Fix squadra Forlì (per l'accento)
				var squadraCasaPath = $(temp_gara).attr("SquadraCasa").split(" ").pop();
				if(squadraCasaPath == "Forlì") {
					squadraCasaPath = "Forli";
				}
				var squadraFuoriPath = $(temp_gara).attr("SquadraFuori").split(" ").pop();
				if(squadraFuoriPath == "Forlì") {
					squadraFuoriPath = "Forli";
				}

				temp_gara = new Gara({
					"giorno" : jQuery('<div>').html($(temp_gara).attr("Giorno")).text(),
					"ora" : $(temp_gara).attr("Ora"),
					"index_campionato" : index_campionato,
					"index_gara" : index_gara,
					"squadraCasa" : $(temp_gara).attr("SquadraCasa"),
					"tifosiSquadraCasa" : tifosiSquadraCasa,
					"squadraFuori" : $(temp_gara).attr("SquadraFuori"),
					"tifosiSquadraFuori" : tifosiSquadraFuori,
					"setVintiCasa" : $(temp_gara).attr("SetVintiCasa"),
					"setVintiFuori" : $(temp_gara).attr("SetVintiFuori"),
					"notificaSquadraCasa" : notifica_squadraA_lbl,
					"notifiche_list_squadraA" : notifiche_list_squadraA,
					"notifiche_list_squadraB" : notifiche_list_squadraB,
					"notificaSquadraFuori" : notifica_squadraB_lbl,
					"campionato" : $(temp_campionato).attr("Serie"),
					"sets" : sets,
					"FacebookPostID" : FacebookPostID,
					"numeroLikes" : numeroLikes,
					"numeroCommenti" : numeroCommenti,
					"imageCasa" : 'img/loghi_club/' + $(temp_campionato).attr("Serie") + path + '/' + squadraCasaPath + '.jpg',
					"imageFuori" : 'img/loghi_club/' + $(temp_campionato).attr("Serie") + path + '/' + squadraFuoriPath + '.jpg'
				});
					
				showPartita(JSON.parse(JSON.stringify(temp_gara)), filter, refresh);
			},
			complete : function() {
				setTimeout(refreshResults, 25000);
			}
		});
	}

	return {
		init : init
	};
});