define(["app", "js/models/campionatoModel", "js/models/garaModel", "js/models/setModel", "js/partite/partiteView", "text!js/homepage/list.html"], function(app, Campionato, Gara, Set, PartiteView, ListTemplate) {
	var sesso = "";
	var modulo = "";
	var campionati = [];
	var bindings = [{
		element : '.partita-item',
		event : 'click',
		handler : showPartita
	}, {
		element : '.sito_federazione',
		event : 'click',
		handler : showSitoFederazione
	}, {
		element : '.show-calendario-A1',
		event : 'click',
		handler : showCalendarioA1
	}, {
		element : '.show-calendario-A2',
		event : 'click',
		handler : showCalendarioA2
	}, {
		element : '.show-calendario-completo',
		event : 'click',
		handler : showCalendarioCompleto
	}, {
		element : '.show-calendario-A1-femminile',
		event : 'click',
		handler : showCalendarioA1Femminile
	}, {
		element : '.show-calendario-A2-femminile',
		event : 'click',
		handler : showCalendarioA2Femminile
	}, {
		element : '.show-calendario-completo-femminile',
		event : 'click',
		handler : showCalendarioCompletoFemminile
	}];

	function showCalendarioCompleto() {
		app.router.load('calendario', {
			Sesso : "CalendarioCompleto",
			modulo : "calendario",
			hide_campionati : false
		});
	}

	function showCalendarioA1() {
		app.router.load('calendario', {
			Sesso : "CalendarioA1",
			modulo : "calendario",
			hide_campionati : true
		});
	}

	function showCalendarioA2() {
		app.router.load('calendario', {
			Sesso : "CalendarioA2",
			modulo : "calendario",
			hide_campionati : true
		});
	}
	
	function showCalendarioCompletoFemminile() {
		app.router.load('calendario', {
			Sesso : "CalendarioCompletoFemminile",
			modulo : "calendario",
			hide_campionati : false
		});
	}

	function showCalendarioA1Femminile() {
		app.router.load('calendario', {
			Sesso : "CalendarioA1Femminile",
			modulo : "calendario",
			hide_campionati : true
		});
	}

	function showCalendarioA2Femminile() {
		app.router.load('calendario', {
			Sesso : "CalendarioA2Femminile",
			modulo : "calendario",
			hide_campionati : true
		});
	}

	function init(query) {
		if(app.utils.checkConnection() == true) {
			sesso = query.Sesso;
			modulo = query.modulo;
			app.utils.Log("INIT partiteController");
			
			var compiled_template = Template7.compile(ListTemplate);
			var html = compiled_template({
				"modulo" : modulo,
				"notifiche" : app.utils.getClassNotifiche
			});
			app.mainView.router.loadPage({
				content : html
			});
				
			app.f7.showIndicator();
			loadCampionati("", false);
	
			$('.pull-to-refresh-content' + '.' + modulo + '-refresh').bind('refresh', function(e) {
				e.stopPropagation();
				refreshResults();
			});
	
			$('#refresh_link_' + modulo).bind('click', function(e) {
				e.stopPropagation();
				refreshResults();
			});
	
			app.utils.googleAnalytics('send', 'pageview', {
				'page' : getHeader()
			});
		} else {
			app.utils.ajaxError();
		}
	}

	function getHeader() {
		var header = "";
		switch (sesso) {
			case "RealTime" :
				header = "Partite Live";
				break;
			case "RealTimeFemminile" :
				header = "Partite Live Femminile";
				break;
			default :
				break;
		}
		return header;
	}

	function showSitoFederazione() {
		app.utils.WindowOpen('http://www.federvolley.it/index.php?page=60&area=14&m=2&sm=60');
	}

	function showPartita(index) {
		app.router.load('partita', {
			index_campionato : $(this).attr('k_custom_id_campionato'),
			index_gara : $(this).attr('k_custom_id_gara'),
			modulo : 'partita',
			sesso : sesso
		});
	}

	function refreshResults() {
		app.f7.showIndicator();
		setTimeout(function() {
			app.f7.hideIndicator();
			loadCampionati("", true);
		}, 1000);
	}

	function loadCampionati(filter, refresh) {
		campionati = [];
		tempInitializeStorage(filter, refresh);
	}

	function showCampionati(temp_campionati, filter, refresh) {
		if (filter) {
			temp_campionati = _.filter(temp_campionati, filter);
		}
		
		campionati = temp_campionati;

		PartiteView.render({
			bindings : bindings,
			header : getHeader(),
			modulo : modulo,
			sesso : sesso,
			model : campionati
		});

		if (refresh) {
			app.f7.pullToRefreshDone();

			app.f7.addNotification({
				title : 'Info',
				subtitle : '',
				message : getHeader() + ', dati aggiornati!',
				hold : 2000,
				media : '<i class="icon icon-refresh"></i>'
			});

			app.utils.googleAnalytics('send', 'event', 'list refresh', getHeader() + ', dati aggiornati!');
		}
	}

	function tempInitializeStorage(filter, refresh) {
		var temp_campionati = [];

		$.ajax({
			method : "GET",
			url : app.utils.GetRisorsa(sesso),
			dataType : "xml",
			timeout: 15000,
			beforeSend : function(xhr, opts) {
				if(!app.utils.checkConnection()) {
					xhr.abort();
					app.utils.ajaxError();
				} else {
					app.f7.showIndicator();
				}
			},
			error : function() {
				app.utils.ajaxError();
			},
			success : function(data) {
				app.f7.hideIndicator();
				var gare = [];
				var sets = [];
				if ($(data).find("CAMPIONATO").length > 0) {
					$(data).find("CAMPIONATO").each(function(index, value) {
						gare = [];
						$(value).find("GARA").each(function(index2, value2) {
							sets = [];
							$(value2).find("SET").each(function(index3, value3) {
								sets.push(new Set({
									"numero" : $(value3).attr("Numero"),
									"puntiCasa" : $(value3).attr("PuntiCasa"),
									"puntiFuori" : $(value3).attr("PuntiFuori")
								}));
							});
							
							var tifosiSquadraCasa = 0;
							var tifosiSquadraFuori = 0;
							$(data).find("InfoSquadra").each(function(index_tif, tifosi) {
								if($(tifosi).attr('name') == $(value2).attr("SquadraCasa")) {
									tifosiSquadraCasa = $(tifosi).attr('tifosi');
								}
								if($(tifosi).attr('name') == $(value2).attr("SquadraFuori")) {
									tifosiSquadraFuori = $(tifosi).attr('tifosi');
								}
							});

							gare.push(new Gara({
								"giorno" : jQuery('<div>').html($(value2).attr("Giorno")).text(),
								"ora" : $(value2).attr("Ora"),
								"index_campionato" : index,
								"index_gara" : index2,
								"squadraCasa" : $(value2).attr("SquadraCasa"),
								"tifosiSquadraCasa" : tifosiSquadraCasa,
								"squadraFuori" : $(value2).attr("SquadraFuori"),
								"tifosiSquadraFuori" : tifosiSquadraFuori,
								"setVintiCasa" : $(value2).attr("SetVintiCasa"),
								"setVintiFuori" : $(value2).attr("SetVintiFuori"),
								"campionato" : $(value).attr("Serie"),
								"sets" : sets
							}));
						});

						temp_campionati.push(new Campionato({
							"fase" : $(value).attr("Fase"),
							"nome" : $(value).attr("Nome"),
							"serie" : $(value).attr("Serie"),
							"gare" : gare
						}));
					});
				}

				showCampionati(JSON.parse(JSON.stringify({
					campionati : temp_campionati
				})), filter, refresh);
			}
		});
	}

	return {
		init : init
	};
});