define(function() {
	var f7 = {};
	var $$ = {};
	var mainView = {};
	var log_ref = $('#customlog').children();
	function checkConnection() {	
		var connected = getLocalConfig("connected");
		
		if(connected == "true") {
			$$('.radio_streaming').show();
			return true;
		} else {
			$$('.radio_streaming').hide();
			return false;
		}
	}

	// esci dall'app
	function exitFromApp() {
		navigator.app.exitApp();
	}

	function getClassNotifiche() {
		var ricevi_notifiche = getLocalConfig("ricevi_notifiche");
		var notifiche_class = "notifiche_off";
		if (ricevi_notifiche == "true") {
			notifiche_class = "notifiche_on";
		}

		return notifiche_class;
	}

	function WindowOpen(url) {
		if (url != "" && url != undefined) {
			f7.showIndicator();
			window.open(url, '_blank', 'location=no,closebuttoncaption=Chiudi,enableViewportScale=no');
			googleAnalytics('send', 'event', 'href click', url);
			f7.hideIndicator();
		}
	}

	// popup uscita app
	function exitAppPopup() {
		navigator.notification.confirm('Vuoi uscire da questa applicazione?', function(button) {
			if (button == 2) {
				navigator.app.exitApp();
			}
		}, 'Attenzione!', 'No,Sì');
		return false;
	}

	function getRndVal() {
		return Math.floor(1000000 + Math.random() * (9999999 - 1000000));
	}

	function setLocalConfig(Key, Value) {
		Log("setLocalConfig [" + Key + "]=" + Value);

		localStorage[Key] = Value;
	}

	function getLocalConfig(Key, parameters) {
		if (parameters === undefined) {
			parameters = {};
		}
		Log("getLocalConfig [" + Key + "]=" + localStorage[Key]);

		if (localStorage[Key] === undefined && parameters.defaultValue !== undefined) {
			Log("getLocalConfig [" + Key + "] is not set, setting defaultValue=" + parameters.defaultValue);
			return parameters.defaultValue;
		} else {

			/*
			 * in caso di stringa false forzo un risultato boolean
			 */
			if (localStorage[Key] == "false") {
				return false;
			}

			return localStorage[Key];
		}
	}

	function GetPushNotification(Squadra) {
		return getLocalConfig("PushNotification_" + Squadra, {
			defaultValue : 'None'
		});
	}
	function GetPreferenzaSquadra(Squadra) {
		return getLocalConfig("Preferenza_" + Squadra, {
			defaultValue : false
		});
	}
	function SetPreferenzaSquadra(Squadra, Stato) {
		var Url = GetRisorsa("SaveTeamPreferences");
		var deviceUUID = getLocalConfig("DeviceUUID");

		$.ajax({
			type : "POST",
			async : true,
			url : Url,
			data : {
				DeviceUUID : deviceUUID,
				Squadra : Squadra,
				Stato : Stato
			},
			dataType : "json",
			success : function(data) {
				if (data.success) {
					if (Stato) {
						f7.addNotification({
							title : 'Info',
							subtitle : '',
							message : 'Squadra: ' + Squadra + ', preferenza impostata',
							hold : 2000,
							media : '<i class="icon icon-refresh"></i>'
						});

						setLocalConfig("Preferenza_" + Squadra, true);
					} else {
						f7.addNotification({
							title : 'Info',
							subtitle : '',
							message : 'Squadra: ' + Squadra + ', preferenza rimossa',
							hold : 2000,
							media : '<i class="icon icon-refresh"></i>'
						});

						setLocalConfig("Preferenza_" + Squadra, false);
					}

				} else {
					f7.modal({
						title : 'Errore',
						text : "C'è stato un errore nella richiesta",
						buttons : [{
							text : 'Riprova',
							onClick : function() {}
						}]
					});
				}
			}
		});
	}
	function SetPushNotification(Squadra, Evento, Sesso, parameters) {
		if (parameters == undefined) {
			parameters = {};
		}
		var Url = GetRisorsa("SavePushPreferences");

		var NotificationID = getLocalConfig("NotificationID");
		var DeviceType = getLocalConfig("DeviceType");
		var deviceUUID = getLocalConfig("DeviceUUID");

		var label = "";
		switch (Evento) {
			case "None" :
				label = "Nessuna";
				break;
			case "Match" :
				label = "Partita";
				break;
			case "Set" :
				label = "Set";
				break;
			case "Point" :
				label = "Tutti i punti!";
				break;
		}

		$.ajax({
			type : "POST",
			async : true,
			url : Url,
			data : {
				NotificationID : NotificationID,
				DeviceType : DeviceType,
				DeviceUUID : deviceUUID,
				Squadra : Squadra,
				Evento : Evento,
				Sesso : Sesso
			},
			dataType : "json",
			success : function(data) {
				if (data.success) {
					f7.addNotification({
						title : 'Info',
						subtitle : '',
						message : 'Squadra: ' + Squadra + ', notifica impostata a ' + label,
						hold : 2000,
						media : '<i class="icon icon-refresh"></i>'
					});

					setLocalConfig("PushNotification_" + Squadra, Evento);

					if (parameters.filter != "") {
						$('#' + parameters.filter_ID).attr('class', 'notifica ' + label.split(" ")[0] + ' smart-select');
					} else {
						$('#' + parameters.id + '-content').html(label).attr('class', 'item-after ' + label);
					}
				} else {
					f7.modal({
						title : 'Errore',
						text : "C'è stato un errore nella richiesta",
						buttons : [{
							text : 'Riprova',
							onClick : function() {
								// location.reload();
							}
						}]
					});
				}
			}
		});
	}

	function RegisterPushNotification() {
		try {
			var pushNotification = window.plugins.pushNotification;

			if (device.platform == 'android' || device.platform == 'Android') {
				pushNotification.register(function(result) {
					Log("pushNotification succesfully registered: " + result);
				}, function(result) {
					Log("pushNotification error: " + result);
				}, {
					"senderID" : "131109016310",
					"ecb" : "onNotificationGCM"
				});
			} else {
				pushNotification.register(function(result) {
					Log("pushNotification succesfully registered: " + result);
					setLocalConfig("NotificationID", result);
				}, function(result) {
					Log("pushNotification error: " + result);
				}, {
					"badge" : "true",
					"sound" : "true",
					"alert" : "true",
					"ecb" : "onNotificationAPN"
				});

			}
		} catch (error) {
			Log("pushNotification catch error:" + error);
		}
	}

	function SetDati2Use(dati2use) {
		/*
		 * TEST_LOCALE = xml statici in /data LEGAVOLLEY_DEV = xml di test
		 * LEGAVOLLEY_DEV = xml di produzione legavolley (salvataggio notifiche
		 * DB di debug) LEGAVOLLEY_PRD = xml di produzione legavolley
		 */
		setLocalConfig("DatiUtilizzati", dati2use);
	}

	function GetRisorsa(TipoRisorsa) {
		var DatiUtilizzati = getLocalConfig("DatiUtilizzati");

		Log("Tipo Risorsa: " + TipoRisorsa);
		Log("Dati utilizzati: " + DatiUtilizzati);

		var path = "";

		if (TipoRisorsa == "A1") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/classifica_serie_A1.xml?V=2014";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV" || DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolley.it/XMLClassifica.asp?idSerie=1";
			}
		}
		if (TipoRisorsa == "A1Femminile") {

			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/classifica_serie_A1Femminile.xml?V=2014";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV" || DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolleyfemminile.it/XMLClassifica.asp?idSerie=1";
			}
		}
		if (TipoRisorsa == "A2") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/classifica_serie_A2.xml?V=2014";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV" || DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolley.it/XMLClassifica.asp?idSerie=2";
			}

		}
		if (TipoRisorsa == "A2Femminile") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/classifica_serie_A2Femminile.xml?V=2014";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV" || DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolleyfemminile.it/XMLClassifica.asp?idSerie=2";
			}

		}
		if (TipoRisorsa == "RealTime") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/realtime.xml";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://volleytest.kumbe.it/data/xml_test_generator.php?sesso=maschile";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://volley.kumbe.it/data/realtime.xml?v=" + getRndVal();
			}

		}
		if (TipoRisorsa == "RealTimeFemminile") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/realtime_femminile.xml";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://volleytest.kumbe.it/data/xml_test_generator.php?sesso=femminile";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://volley.kumbe.it/data/realtime_femminile.xml?v=" + getRndVal();
			}

		}

		if (TipoRisorsa == "SavePushPreferences") {
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://volleytest.kumbe.it/index.php?Action=SavePushPreferences";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://volley.kumbe.it/index.php?Action=SavePushPreferences";
			}
		}

		if (TipoRisorsa == "SaveTeamPreferences") {
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://volleytest.kumbe.it/index.php?Action=SaveTeamPreferences";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://volley.kumbe.it/index.php?Action=SaveTeamPreferences";
			}
		}

		if (TipoRisorsa == "DeletePushPreferences") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://volleytest.kumbe.it/index.php?Action=DeletePushPreferences";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://volley.kumbe.it/index.php?Action=DeletePushPreferences";
			}
		}
		
		if (TipoRisorsa == "SendFeedback") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://volleytest.kumbe.it/index.php?Action=SendFeedback";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://volley.kumbe.it/index.php?Action=SendFeedback";
			}
		}

		if (TipoRisorsa == "RssFeedLega") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/RssFeedLega.xml";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://www.legavolley.it/rss.asp";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolley.it/rss.asp";
			}
		}

		if (TipoRisorsa == "RssFeedLegaFemminile") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/RssFeedLegaFemminile.xml";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://www.legavolleyfemminile.it/rss.asp";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolleyfemminile.it/rss.asp";
			}
		}

		if (TipoRisorsa == "RssFeedLegaDettaglio") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/news.json";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://volleytest.kumbe.it/index.php?Action=GetNews";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://volley.kumbe.it/index.php?Action=GetNews";
			}
		}

		if (TipoRisorsa == "CalendarioA1") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/CalendarioA1.xml";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://www.legavolley.it/xmlCalendario.asp?idserie=1";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolley.it/xmlCalendario.asp?idserie=1";
			}
		}

		if (TipoRisorsa == "CalendarioA2") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/CalendarioA2.xml";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://www.legavolley.it/xmlCalendario.asp?idserie=2";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolley.it/xmlCalendario.asp?idserie=2";
			}
		}

		if (TipoRisorsa == "CalendarioA1Femminile") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/CalendarioA1Femminile.xml";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://www.legavolleyfemminile.it/xmlCalendario.asp?idserie=1";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolleyfemminile.it/xmlCalendario.asp?idserie=1";
			}
		}

		if (TipoRisorsa == "CalendarioA2Femminile") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/CalendarioA2Femminile.xml";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://www.legavolleyfemminile.it/xmlCalendario.asp?idserie=2";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolleyfemminile.it/xmlCalendario.asp?idserie=2";
			}
		}

		if (TipoRisorsa == "CalendarioCompleto") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/Calendario.xml";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://www.legavolley.it/xmlCalendario.asp";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolley.it/xmlCalendario.asp";
			}
		}

		if (TipoRisorsa == "CalendarioCompletoFemminile") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/CalendarioFemminile.xml";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://www.legavolleyfemminile.it/xmlCalendario.asp";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://www.legavolleyfemminile.it/xmlCalendario.asp";
			}
		}

		if (TipoRisorsa == "Newsletter") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "http://volleytest.kumbe.it/index.php?Action=GetNewsletter";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "http://volley.kumbe.it/index.php?Action=GetNewsletter";
			}
		}

		if (TipoRisorsa == "Commenti") {
			if (DatiUtilizzati == "TEST_LOCALE") {
				path = "./data/commenti.json";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_DEV") {
				path = "./data/commenti.json";
			}
			if (DatiUtilizzati == "LEGAVOLLEY_PRD") {
				path = "./data/commenti.json";
			}
		}

		Log("URL: " + path);
		return path;
	}

	function Log(message) {
		var element = document.createElement("p");

		var str_to_print = "";
		if (typeof message === 'object') {
			str_to_print = JSON.stringify(message);
		} else {
			str_to_print = message;
		}
		element.appendChild(document.createTextNode(str_to_print));

		try {
			// ripulisco dom
			if (log_ref.html().length > 2500)
				log_ref.html("reset");
			log_ref.prepend(element);
		} catch (Exception) {
		}
	}

	function switchTheme() {
		var layout = getLocalConfig("layout");
		// CAMBIA TEMA
		if (layout != undefined || layout != null) {
			var layouts = 'layout-white layout-black';

			if (layout == "layout-dark") {
				$('#imposta-tema').prop('checked', true);
			} else {
				$('#imposta-tema').prop('checked', false);
			}

			$('body').removeClass(layouts).addClass(layout);
		}
	}

	function switchNotifiche() {
		if (getLocalConfig("ricevi_notifiche") == "true") {
			$('.notifiche').removeClass("notifiche_off").addClass("notifiche_on");
			$('#imposta-notifiche').prop('checked', true);
		} else {
			$('.notifiche').removeClass("notifiche_on").addClass("notifiche_off");
			$('#imposta-notifiche').prop('checked', false);
		}
	}

	function SocialShare(messaggio, oggetto, allegato, link, ga_text) {
		f7.showIndicator();
		window.plugins.socialsharing.share(messaggio, oggetto, allegato, link);
		googleAnalytics('send', 'event', 'button click', ga_text);
		f7.hideIndicator();
	}

	function setApp(f7_ref, Dom7_ref, mainView_ref) {
		f7 = f7_ref;
		$$ = Dom7_ref;
		mainView = mainView_ref;
	}

	function clearAllTimeouts() {
		var id = window.setTimeout(function() {
		}, 0);

		while (id--) {
			window.clearTimeout(id);
		}
	}

	function RemovePushNotifications(deviceUUID) {
		var today = new Date();
		var dd = today.getDate();
		var mm = today.getMonth() + 1;
		var yyyy = today.getFullYear();

		var hash = md5(deviceUUID + "_" + yyyy + "-" + mm + "-" + dd + "_volley_real_time");

		var Url = GetRisorsa("DeletePushPreferences");

		$.ajax({
			type : "POST",
			async : true,
			url : Url,
			data : {
				uuid : deviceUUID,
				hash : hash
			},
			dataType : "json",
			success : function(data) {
				if (data.success) {
					Log("Rimozione eseguita correttamente");
				} else {
					Log("Errore nell'eliminazione delle notifiche relative al dispositivo");
				}
			}
		});
	}

	function utf8_encode(argString) {
		// discuss at: http://phpjs.org/functions/utf8_encode/
		// original by: Webtoolkit.info (http://www.webtoolkit.info/)
		// improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
		// improved by: sowberry
		// improved by: Jack
		// improved by: Yves Sucaet
		// improved by: kirilloid
		// bugfixed by: Onno Marsman
		// bugfixed by: Onno Marsman
		// bugfixed by: Ulrich
		// bugfixed by: Rafal Kukawski
		// bugfixed by: kirilloid
		// example 1: utf8_encode('Kevin van Zonneveld');
		// returns 1: 'Kevin van Zonneveld'

		if (argString === null || typeof argString === 'undefined') {
			return '';
		}

		var string = (argString + ''); // .replace(/\r\n/g,
		// "\n").replace(/\r/g, "\n");
		var utftext = '', start, end, stringl = 0;

		start = end = 0;
		stringl = string.length;
		for (var n = 0; n < stringl; n++) {
			var c1 = string.charCodeAt(n);
			var enc = null;

			if (c1 < 128) {
				end++;
			} else if (c1 > 127 && c1 < 2048) {
				enc = String.fromCharCode((c1 >> 6) | 192, (c1 & 63) | 128);
			} else if ((c1 & 0xF800) != 0xD800) {
				enc = String.fromCharCode((c1 >> 12) | 224, ((c1 >> 6) & 63) | 128, (c1 & 63) | 128);
			} else { // surrogate pairs
				if ((c1 & 0xFC00) != 0xD800) {
					throw new RangeError('Unmatched trail surrogate at ' + n);
				}
				var c2 = string.charCodeAt(++n);
				if ((c2 & 0xFC00) != 0xDC00) {
					throw new RangeError('Unmatched lead surrogate at ' + (n - 1));
				}
				c1 = ((c1 & 0x3FF) << 10) + (c2 & 0x3FF) + 0x10000;
				enc = String.fromCharCode((c1 >> 18) | 240, ((c1 >> 12) & 63) | 128, ((c1 >> 6) & 63) | 128, (c1 & 63) | 128);
			}
			if (enc !== null) {
				if (end > start) {
					utftext += string.slice(start, end);
				}
				utftext += enc;
				start = end = n + 1;
			}
		}

		if (end > start) {
			utftext += string.slice(start, stringl);
		}

		return utftext;
	}

	function md5(str) {
		// discuss at: http://phpjs.org/functions/md5/
		// original by: Webtoolkit.info (http://www.webtoolkit.info/)
		// improved by: Michael White (http://getsprink.com)
		// improved by: Jack
		// improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
		// input by: Brett Zamir (http://brett-zamir.me)
		// bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
		// depends on: utf8_encode
		// example 1: md5('Kevin van Zonneveld');
		// returns 1: '6e658d4bfcb59cc13f96c14450ac40b9'

		var xl;

		var rotateLeft = function(lValue, iShiftBits) {
			return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
		};

		var addUnsigned = function(lX, lY) {
			var lX4, lY4, lX8, lY8, lResult;
			lX8 = (lX & 0x80000000);
			lY8 = (lY & 0x80000000);
			lX4 = (lX & 0x40000000);
			lY4 = (lY & 0x40000000);
			lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
			if (lX4 & lY4) {
				return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
			}
			if (lX4 | lY4) {
				if (lResult & 0x40000000) {
					return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
				} else {
					return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
				}
			} else {
				return (lResult ^ lX8 ^ lY8);
			}
		};

		var _F = function(x, y, z) {
			return (x & y) | ((~x) & z);
		};
		var _G = function(x, y, z) {
			return (x & z) | (y & (~z));
		};
		var _H = function(x, y, z) {
			return (x ^ y ^ z);
		};
		var _I = function(x, y, z) {
			return (y ^ (x | (~z)));
		};

		var _FF = function(a, b, c, d, x, s, ac) {
			a = addUnsigned(a, addUnsigned(addUnsigned(_F(b, c, d), x), ac));
			return addUnsigned(rotateLeft(a, s), b);
		};

		var _GG = function(a, b, c, d, x, s, ac) {
			a = addUnsigned(a, addUnsigned(addUnsigned(_G(b, c, d), x), ac));
			return addUnsigned(rotateLeft(a, s), b);
		};

		var _HH = function(a, b, c, d, x, s, ac) {
			a = addUnsigned(a, addUnsigned(addUnsigned(_H(b, c, d), x), ac));
			return addUnsigned(rotateLeft(a, s), b);
		};

		var _II = function(a, b, c, d, x, s, ac) {
			a = addUnsigned(a, addUnsigned(addUnsigned(_I(b, c, d), x), ac));
			return addUnsigned(rotateLeft(a, s), b);
		};

		var convertToWordArray = function(str) {
			var lWordCount;
			var lMessageLength = str.length;
			var lNumberOfWords_temp1 = lMessageLength + 8;
			var lNumberOfWords_temp2 = (lNumberOfWords_temp1 - (lNumberOfWords_temp1 % 64)) / 64;
			var lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
			var lWordArray = new Array(lNumberOfWords - 1);
			var lBytePosition = 0;
			var lByteCount = 0;
			while (lByteCount < lMessageLength) {
				lWordCount = (lByteCount - (lByteCount % 4)) / 4;
				lBytePosition = (lByteCount % 4) * 8;
				lWordArray[lWordCount] = (lWordArray[lWordCount] | (str.charCodeAt(lByteCount) << lBytePosition));
				lByteCount++;
			}
			lWordCount = (lByteCount - (lByteCount % 4)) / 4;
			lBytePosition = (lByteCount % 4) * 8;
			lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
			lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
			lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
			return lWordArray;
		};

		var wordToHex = function(lValue) {
			var wordToHexValue = '', wordToHexValue_temp = '', lByte, lCount;
			for (lCount = 0; lCount <= 3; lCount++) {
				lByte = (lValue >>> (lCount * 8)) & 255;
				wordToHexValue_temp = '0' + lByte.toString(16);
				wordToHexValue = wordToHexValue + wordToHexValue_temp.substr(wordToHexValue_temp.length - 2, 2);
			}
			return wordToHexValue;
		};

		var x = [], k, AA, BB, CC, DD, a, b, c, d, S11 = 7, S12 = 12, S13 = 17, S14 = 22, S21 = 5, S22 = 9, S23 = 14, S24 = 20, S31 = 4, S32 = 11, S33 = 16, S34 = 23, S41 = 6, S42 = 10, S43 = 15, S44 = 21;

		str = utf8_encode(str);
		x = convertToWordArray(str);
		a = 0x67452301;
		b = 0xEFCDAB89;
		c = 0x98BADCFE;
		d = 0x10325476;

		xl = x.length;
		for (k = 0; k < xl; k += 16) {
			AA = a;
			BB = b;
			CC = c;
			DD = d;
			a = _FF(a, b, c, d, x[k + 0], S11, 0xD76AA478);
			d = _FF(d, a, b, c, x[k + 1], S12, 0xE8C7B756);
			c = _FF(c, d, a, b, x[k + 2], S13, 0x242070DB);
			b = _FF(b, c, d, a, x[k + 3], S14, 0xC1BDCEEE);
			a = _FF(a, b, c, d, x[k + 4], S11, 0xF57C0FAF);
			d = _FF(d, a, b, c, x[k + 5], S12, 0x4787C62A);
			c = _FF(c, d, a, b, x[k + 6], S13, 0xA8304613);
			b = _FF(b, c, d, a, x[k + 7], S14, 0xFD469501);
			a = _FF(a, b, c, d, x[k + 8], S11, 0x698098D8);
			d = _FF(d, a, b, c, x[k + 9], S12, 0x8B44F7AF);
			c = _FF(c, d, a, b, x[k + 10], S13, 0xFFFF5BB1);
			b = _FF(b, c, d, a, x[k + 11], S14, 0x895CD7BE);
			a = _FF(a, b, c, d, x[k + 12], S11, 0x6B901122);
			d = _FF(d, a, b, c, x[k + 13], S12, 0xFD987193);
			c = _FF(c, d, a, b, x[k + 14], S13, 0xA679438E);
			b = _FF(b, c, d, a, x[k + 15], S14, 0x49B40821);
			a = _GG(a, b, c, d, x[k + 1], S21, 0xF61E2562);
			d = _GG(d, a, b, c, x[k + 6], S22, 0xC040B340);
			c = _GG(c, d, a, b, x[k + 11], S23, 0x265E5A51);
			b = _GG(b, c, d, a, x[k + 0], S24, 0xE9B6C7AA);
			a = _GG(a, b, c, d, x[k + 5], S21, 0xD62F105D);
			d = _GG(d, a, b, c, x[k + 10], S22, 0x2441453);
			c = _GG(c, d, a, b, x[k + 15], S23, 0xD8A1E681);
			b = _GG(b, c, d, a, x[k + 4], S24, 0xE7D3FBC8);
			a = _GG(a, b, c, d, x[k + 9], S21, 0x21E1CDE6);
			d = _GG(d, a, b, c, x[k + 14], S22, 0xC33707D6);
			c = _GG(c, d, a, b, x[k + 3], S23, 0xF4D50D87);
			b = _GG(b, c, d, a, x[k + 8], S24, 0x455A14ED);
			a = _GG(a, b, c, d, x[k + 13], S21, 0xA9E3E905);
			d = _GG(d, a, b, c, x[k + 2], S22, 0xFCEFA3F8);
			c = _GG(c, d, a, b, x[k + 7], S23, 0x676F02D9);
			b = _GG(b, c, d, a, x[k + 12], S24, 0x8D2A4C8A);
			a = _HH(a, b, c, d, x[k + 5], S31, 0xFFFA3942);
			d = _HH(d, a, b, c, x[k + 8], S32, 0x8771F681);
			c = _HH(c, d, a, b, x[k + 11], S33, 0x6D9D6122);
			b = _HH(b, c, d, a, x[k + 14], S34, 0xFDE5380C);
			a = _HH(a, b, c, d, x[k + 1], S31, 0xA4BEEA44);
			d = _HH(d, a, b, c, x[k + 4], S32, 0x4BDECFA9);
			c = _HH(c, d, a, b, x[k + 7], S33, 0xF6BB4B60);
			b = _HH(b, c, d, a, x[k + 10], S34, 0xBEBFBC70);
			a = _HH(a, b, c, d, x[k + 13], S31, 0x289B7EC6);
			d = _HH(d, a, b, c, x[k + 0], S32, 0xEAA127FA);
			c = _HH(c, d, a, b, x[k + 3], S33, 0xD4EF3085);
			b = _HH(b, c, d, a, x[k + 6], S34, 0x4881D05);
			a = _HH(a, b, c, d, x[k + 9], S31, 0xD9D4D039);
			d = _HH(d, a, b, c, x[k + 12], S32, 0xE6DB99E5);
			c = _HH(c, d, a, b, x[k + 15], S33, 0x1FA27CF8);
			b = _HH(b, c, d, a, x[k + 2], S34, 0xC4AC5665);
			a = _II(a, b, c, d, x[k + 0], S41, 0xF4292244);
			d = _II(d, a, b, c, x[k + 7], S42, 0x432AFF97);
			c = _II(c, d, a, b, x[k + 14], S43, 0xAB9423A7);
			b = _II(b, c, d, a, x[k + 5], S44, 0xFC93A039);
			a = _II(a, b, c, d, x[k + 12], S41, 0x655B59C3);
			d = _II(d, a, b, c, x[k + 3], S42, 0x8F0CCC92);
			c = _II(c, d, a, b, x[k + 10], S43, 0xFFEFF47D);
			b = _II(b, c, d, a, x[k + 1], S44, 0x85845DD1);
			a = _II(a, b, c, d, x[k + 8], S41, 0x6FA87E4F);
			d = _II(d, a, b, c, x[k + 15], S42, 0xFE2CE6E0);
			c = _II(c, d, a, b, x[k + 6], S43, 0xA3014314);
			b = _II(b, c, d, a, x[k + 13], S44, 0x4E0811A1);
			a = _II(a, b, c, d, x[k + 4], S41, 0xF7537E82);
			d = _II(d, a, b, c, x[k + 11], S42, 0xBD3AF235);
			c = _II(c, d, a, b, x[k + 2], S43, 0x2AD7D2BB);
			b = _II(b, c, d, a, x[k + 9], S44, 0xEB86D391);
			a = addUnsigned(a, AA);
			b = addUnsigned(b, BB);
			c = addUnsigned(c, CC);
			d = addUnsigned(d, DD);
		}

		var temp = wordToHex(a) + wordToHex(b) + wordToHex(c) + wordToHex(d);

		return temp.toLowerCase();
	}

	function FBInit() {
		var user = getLocalConfig("FB_user");
		if (user != "undefined" && user != undefined) {
			var parsed_user = JSON.parse(user);

			var tokenStore = [];
			tokenStore['fbtoken'] = parsed_user.token;

			openFB.init({
				appId : "373227372839007",
				tokenStore : tokenStore
			});
		} else {
			openFB.init({
				"appId" : "373227372839007"
			});
		}
	}
	
	function FBLogout() {
		googleAnalytics('send', 'event', 'button click', 'Logout dell utente');
		if (checkConnection() == true) {
			// Modal per conferma
			f7.modal({
				title : 'Logout FB',
				text : 'Desideri uscire da Facebook? (Non potrai più postare commenti fino al prossimo login)',
				buttons : [{
					text : 'SI',
					onClick : function() {
						f7.showIndicator();
						openFB.logout(function() {
							// svuoto i dati relativi all'account dell'utente
							setLocalConfig("FB_user", undefined);

							// Imposto l'immagine di login
							$$('.fb-button').removeClass('fb-logout').addClass('fb-login');
							$$('.fb-logout').removeClass('fb-logout').addClass('fb-login');
							
							$$('#fb-logout').hide();

							f7.addNotification({
								title : 'Facebook',
								subtitle : '',
								message : 'Logout effettuato con successo',
								hold : 3000,
								media : '<i class="icon icon-refresh"></i>'
							});
							
							f7.hideIndicator();
							Log('Logout effettuato con successo');
						});
						setTimeout(function() {
							f7.hideIndicator();
						}, 1000);
					}
				}, {
					text : 'NO',
					onClick : function() {
						f7.hideIndicator();
					}
				}]
			});
		} else {
			f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}
	
	function FBError(code) {
		if(code == "OAuthException" || code == 102) {
			// API Session expired
			f7.modal({
				title : ':(',
				text : 'Le credenziali sono scadute, rieffettua il login',
				buttons : [{
					text : 'OK',
					onClick : function() {
						setLocalConfig("FB_user", JSON.stringify({}));
						mainView.router.back();
					}
				}]
			});
		}
		if(code == 803) { 
			// FacebookPostID = "ND"
			f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
		if(code == 4 || code == 17) {
			// 4 [API Too Many Calls], 17 [API User Too Many Calls]
			f7.modal({
				title : ':(',
				text : 'Si è verificato un problema con la tua richiesta, riprova più tardi',
				buttons : [{
					text : 'OK',
					onClick : function() {
						mainView.router.back();
					}
				}]
			});
		}
		
		if(code == 10 || code == 459 || code == 467) {
			// 10 [API Permission Denied]
			f7.modal({
				title : ':(',
				text : "Non hai dato i permessi all'applicazione",
				buttons : [{
					text : 'OK',
					onClick : function() {
						mainView.router.back();
					}
				}]
			});
		}
	}
	
	function FBLikeApp() {
		if (checkConnection() == true) {
			f7.showIndicator();
			openFB.api({
				method : 'POST',
				path : '/' + gara.FacebookPostID + '/likes',
				success : function() {
					Log("Like all'app aggiunto correttamente");
					
					$$('#fb-like_app').hide();
				},
				error : function(error) {
					f7.hideIndicator();
				}
			});
		} else {
			f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}
	
	function ajaxError() {
		f7.hideIndicator();

		if (checkConnection() == true) {
			f7.modal({
				title : ':(',
				text : "C'è stato un problema con la tua richiesta",
				buttons : [{
					text : 'Chiudi',
					onClick : function() {
					}
				}]
			});
			setTimeout(function() {
				f7.closeModal();
			}, 3000);
		} else {
			f7.modal({
				title : ':(',
				text : 'Non sei connesso alla rete!',
				buttons : [{
					text : 'Quando ok tocca qui',
					onClick : function() {
						location.reload();
					}
				}]
			});
		}
	}
	
	function googleAnalytics(type, object, name, message) {
		if(checkConnection() == true) {
			if(object == "event") {
				ga(type, object, name, message);
			}
			if(object == "pageview") {
				ga(type, object, message);
			}
		}
	}
	
	function sendFeedback(testo) {		
		var DeviceUUID = getLocalConfig("DeviceUUID");
		var DeviceType = getLocalConfig("DeviceType");
		var Url = GetRisorsa("SendFeedback");

		$.ajax({
			type : "POST",
			async : true,
			url : Url,
			data : {
				DeviceUUID : DeviceUUID,
				DeviceType :DeviceType,
				Content : testo
			},
			dataType : "json",
			success : function(data) {
				if (data.success) {
					Log("Feedback inviato correttamente");
					f7.addNotification({
						title : 'Feedback',
						subtitle : '',
						message : "Grazie per la tua segnalazione ;-)",
						hold : 3000,
						media : '<i class="icon icon-refresh"></i>'
					});
				} else {
					Log("Errore nell'invio del feedback");
					f7.addNotification({
						title : 'Feedback',
						subtitle : '',
						message : "Errore nell'invio della segnalazione, riprovare più tardi",
						hold : 3000,
						media : '<i class="icon icon-refresh"></i>'
					});
				}
			}
		});
	}

	return {
		checkConnection : checkConnection,
		Log : Log,
		getLocalConfig : getLocalConfig,
		switchTheme : switchTheme,
		switchNotifiche : switchNotifiche,
		GetRisorsa : GetRisorsa,
		onNotificationGCM : onNotificationGCM,
		onNotificationAPN : onNotificationAPN,
		exitFromApp : exitFromApp,
		exitAppPopup : exitAppPopup,
		getRndVal : getRndVal,
		setLocalConfig : setLocalConfig,
		GetPushNotification : GetPushNotification,
		SetPushNotification : SetPushNotification,
		RemovePushNotifications : RemovePushNotifications,
		RegisterPushNotification : RegisterPushNotification,
		GetPreferenzaSquadra : GetPreferenzaSquadra,
		SetPreferenzaSquadra : SetPreferenzaSquadra,
		SetDati2Use : SetDati2Use,
		SocialShare : SocialShare,
		WindowOpen : WindowOpen,
		setApp : setApp,
		utf_8_encode : utf8_encode,
		md5 : md5,
		clearAllTimeouts : clearAllTimeouts,
		getClassNotifiche : getClassNotifiche,
		FBInit : FBInit,
		FBLogout : FBLogout,
		FBError : FBError,
		FBLikeApp : FBLikeApp,
		ajaxError : ajaxError,
		googleAnalytics : googleAnalytics,
		sendFeedback : sendFeedback
	};
});